/**
 * \file
 *
 * \brief ۸ޔr(AC)֐
 *
 * 쌠 (c) 2010 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include <stdint.h>

#include "interrupt.h"
#include "compiler.h"
#include "parts.h"

#include "ac.h"
#include "sysclk.h"
#include "sleepmgr.h"
#include "status_codes.h"

#if defined(ACA) || defined(__DOXYGEN__)
//! \internal ۸ޔrA荞݌Ăі߂֐̋ǏL
static ac_callback_t    ac_aca_callback;

/**
 * \internal
 * \brief ۸ޔrÅJꂽ(`Ԑݒ肵ċꂽ)قgpҐ
 *        o܂ۂǏϐ
 */
static uint8_t          ac_aca_opened = 0;

/**
 * \internal
 * \brief ۸ޔrA0p荞ݏ
 *
 * ̊֐ͱ۸ޔrA0̊荞݂A۸ޔrAĂі߂֐
 * Ăт܂B
 */
ISR(ACA_AC0_vect)
{
	if (ac_aca_callback) {
		if (ACA.STATUS & AC_AC0STATE_bm) {
			ac_aca_callback(&ACA, 0, AC_STATUS_ABOVE);
		}
		else {
			ac_aca_callback(&ACA, 0, AC_STATUS_BELOW);
		}
	}
}

/**
 * \internal
 * \brief ۸ޔrA1p荞ݏ
 *
 * ̊֐ͱ۸ޔrA1̊荞݂A۸ޔrAĂі߂֐
 * Ăт܂B
 */
ISR(ACA_AC1_vect)
{
	if (ac_aca_callback) {
		if (ACA.STATUS & AC_AC1STATE_bm) {
			ac_aca_callback(&ACA, 1, AC_STATUS_ABOVE);
		}
		else {
			ac_aca_callback(&ACA, 1, AC_STATUS_BELOW);
		}
	}
}

/**
 * \internal
 * \brief ł̱۸ޔrAp荞ݏ
 *
 * ̊֐͑ł̱۸ޔrÅ荞݂A۸ޔrAĂі߂
 * ֐Ăт܂B
 */
ISR(ACA_ACW_vect)
{
	if (ac_aca_callback) {
		ac_aca_callback(&ACA, 0, (enum ac_status_t)(ACA.STATUS &
					AC_WSTATE_gm));
	}
}
#endif

#if defined(ACB) || defined(__DOXYGEN__)
//! \internal ۸ޔrB荞݌Ăі߂֐̋ǏL
static ac_callback_t    ac_acb_callback;

/**
 * \internal
 * \brief ۸ޔrB̊Jꂽ(`Ԑݒ肵ċꂽ)قgpҐ
 *        o܂ۂǏϐ
 */
static uint8_t          ac_acb_opened = 0;

/**
 * \internal
 * \brief ۸ޔrB0p荞ݏ
 *
 * ̊֐ͱ۸ޔrA0̊荞݂A۸ޔrBĂі߂֐
 * Ăт܂B
 */
ISR(ACB_AC0_vect)
{
	if (ac_acb_callback) {
		if (ACB.STATUS & AC_AC0STATE_bm) {
			ac_acb_callback(&ACB, 0, AC_STATUS_ABOVE);
		}
		else {
			ac_acb_callback(&ACB, 0, AC_STATUS_BELOW);
		}
	}
}

/**
 * \internal
 * \brief ۸ޔrA1p荞ݏ
 *
 * ̊֐ͱ۸ޔrB1̊荞݂A۸ޔrBĂі߂֐
 * Ăт܂B
 */
ISR(ACB_AC1_vect)
{
	if (ac_acb_callback) {
		if (ACB.STATUS & AC_AC1STATE_bm) {
			ac_acb_callback(&ACB, 1, AC_STATUS_ABOVE);
		}
		else {
			ac_acb_callback(&ACB, 1, AC_STATUS_BELOW);
		}
	}
}

/**
 * \internal
 * \brief ł̱۸ޔrBp荞ݏ
 *
 * ̊֐͑ł̱۸ޔrB̊荞݂A۸ޔrBĂі߂
 * ֐Ăт܂B
 */
ISR(ACB_ACW_vect)
{
	if (ac_acb_callback) {
		ac_acb_callback(&ACB, 0, (enum ac_status_t)(ACB.STATUS &
					AC_WSTATE_gm));
	}
}
#endif

/**
 * \brief ʰ޳ɱ۸ޔr`Ԑݒ
 *
 * ̊֐͑I񂾱۸ޔrʰ޳ق \ref ac_config \̂܂B
 *
 * \param  ac      ۸ޔr(AC)ڽւ̈ʒuwq
 * \param  channel ۸ޔr(AC)ق̔ԍ
 * \param  config  \ref ac_config ϐւ̈ʒuwq
 */
void ac_write_config(AC_t *ac, uint8_t channel, struct ac_config *config)
{
	enum sysclk_port_id		sysclk_port;
	irqflags_t				iflags = cpu_irq_save();

#ifdef ACA
	if ((uintptr_t)ac == (uintptr_t)&ACA) {
		sysclk_port = SYSCLK_PORT_A;
		if (!ac_aca_opened) {
			sysclk_enable_module(sysclk_port, SYSCLK_AC);
		}
		ac_aca_opened++;
	} else
#endif
#ifdef ACB
	if ((uintptr_t)ac == (uintptr_t)&ACB) {
		sysclk_port = SYSCLK_PORT_B;
		if (!ac_acb_opened) {
			sysclk_enable_module(sysclk_port, SYSCLK_AC);
		}
		ac_acb_opened++;
	} else
#endif
	{
		cpu_irq_restore(iflags);
		return;
	}

	ac->CTRLB               = config->ctrlb;
	ac->WINCTRL             = config->winctrl;

	if (channel == 0) {
		ac->AC0MUXCTRL  = config->acmuxctrl;
		ac->AC0CTRL     = config->acctrl;
	} else {
		ac->AC1MUXCTRL  = config->acmuxctrl;
		ac->AC1CTRL     = config->acctrl;
	}

#ifdef ACA
	if (sysclk_port == SYSCLK_PORT_A) {
		ac_aca_opened--;
		if (!ac_aca_opened) {
			sysclk_disable_module(SYSCLK_PORT_A, SYSCLK_AC);
		}
	} else
#endif
#ifdef ACB
	if (sysclk_port == SYSCLK_PORT_B) {
		ac_acb_opened--;
		if (!ac_acb_opened) {
			sysclk_disable_module(SYSCLK_PORT_B, SYSCLK_AC);
		}
	} else
#endif
	{
		cpu_irq_restore(iflags);
		return;
	}

	cpu_irq_restore(iflags);
}

/**
 * \brief ʰ޳۸ޔr`Ԑݒǂ
 *
 * ̊֐ʰ޳`Ԑݒǂ \a config ɒu܂B
 *
 * \param  ac      ۸ޔr(AC)ڽւ̈ʒuwq
 * \param  channel ۸ޔr(AC)ق̔ԍ
 * \param  config  \ref ac_config ϐւ̈ʒuwq
 */
void ac_read_config(AC_t *ac, uint8_t channel, struct ac_config *config)
{
	irqflags_t iflags = cpu_irq_save();

	if (channel == 0) {
		config->acmuxctrl   = ac->AC0MUXCTRL;
		config->acctrl      = ac->AC0CTRL;
	} else {
		config->acmuxctrl   = ac->AC1MUXCTRL;
		config->acctrl      = ac->AC1CTRL;
	}

	config->winctrl = ac->WINCTRL;
	config->ctrlb   = ac->CTRLB;

	cpu_irq_restore(iflags);
}

/**
 * \brief ۸ޔrُԂ擾
 *
 * ̊֐͗^ꂽق猻݂̱۸ޔȑԂ擾܂B
 *
 * \param  ac      ۸ޔr(AC)ڽւ̈ʒuwq
 * \param  channel Ԃ𓾂۸ޔr(AC)ق̔ԍ
 *
 * \retval \ref ac_status_t lɂė^۸ޔȑ
 */
enum ac_status_t ac_get_status(AC_t *ac, uint8_t channel)
{
	uint8_t winctrl = ac->WINCTRL;

	if (winctrl & AC_WEN_bm) {
		return (enum ac_status_t)(ac->STATUS & AC_WSTATE_gm);
	}
	else if (channel == 0) {
		if (ac->STATUS & AC_AC0STATE_bm) {
			return AC_STATUS_ABOVE;
		} else {
			return AC_STATUS_BELOW;
		}
	} else {
		if (ac->STATUS & AC_AC1STATE_bm) {
			return AC_STATUS_ABOVE;
		} else {
			return AC_STATUS_BELOW;
		}
	}
}

/**
 * \brief ۸ޔrق
 *
 * \param  ac      ۸ޔr(AC)ڽւ̈ʒuwq
 * \param  channel ۸ޔr(AC)ق̔ԍ
 */
void ac_enable(AC_t *ac, uint8_t channel)
{
	irqflags_t				iflags = cpu_irq_save();

#ifdef ACA
	if ((uintptr_t)ac == (uintptr_t)&ACA) {
		if (!ac_aca_opened) {
			sysclk_enable_module(SYSCLK_PORT_A, SYSCLK_AC);
		}
		ac_aca_opened++;
	} else
#endif
#ifdef ACB
	if ((uintptr_t)ac == (uintptr_t)&ACB) {
		if (!ac_acb_opened) {
			sysclk_enable_module(SYSCLK_PORT_B, SYSCLK_AC);
		}
		ac_acb_opened++;
	} else
#endif
	{
		cpu_irq_restore(iflags);
		return;
	}

	sleepmgr_lock_mode(SLEEPMGR_IDLE);

	if (channel == 0) {
		ac->AC0CTRL |= AC_ENABLE_bm;
	} else {
		ac->AC1CTRL |= AC_ENABLE_bm;
	}

	cpu_irq_restore(iflags);
}

/**
 * \brief ۸ޔrق֎~
 *
 * \param  ac      ۸ޔr(AC)ڽւ̈ʒuwq
 * \param  channel ֎~۸ޔr(AC)ق̔ԍ
 */
void ac_disable(AC_t *ac, uint8_t channel)
{
	irqflags_t				iflags = cpu_irq_save();

	if (channel == 0) {
		ac->AC0CTRL &= ~AC_ENABLE_bm;
	} else {
		ac->AC1CTRL &= ~AC_ENABLE_bm;
	}

	sleepmgr_unlock_mode(SLEEPMGR_IDLE);

#ifdef ACA
	if ((uintptr_t)ac == (uintptr_t)&ACA) {
		ac_aca_opened--;
		if (!ac_aca_opened) {
			sysclk_disable_module(SYSCLK_PORT_A, SYSCLK_AC);
		}
	} else
#endif
#ifdef ACB
	if ((uintptr_t)ac == (uintptr_t)&ACB) {
		ac_acb_opened--;
		if (!ac_acb_opened) {
			sysclk_disable_module(SYSCLK_PORT_B, SYSCLK_AC);
		}
	} else
#endif
	{
		cpu_irq_restore(iflags);
		return;
	}

	cpu_irq_restore(iflags);
}

/**
 * \brief 荞݌Ăі߂֐ݒ
 *
 * ̊֐͊荞݌Ăі߂֐̐ݒƕύXĂяo҂ɋ܂BĂі߂
 * ݒ肷邱ƂȂłײޓ̊荞ݏ荞ݗv׸ނ
 * łB
 *
 * \param  ac       ۸ޔr(AC)ڽւ̈ʒuwq
 * \param  callback Ăі߂֐ւ̎QƊ
 */
void ac_set_interrupt_callback(AC_t *ac, ac_callback_t callback)
{
#ifdef ACA
	if (ac == &ACA) {
		ac_aca_callback = callback;
	}
#endif
#ifdef ACB
	if (ac == &ACB) {
		ac_acb_callback = callback;
	}
#endif
}
