/**
 * \file
 *
 * \brief ݒ\ȑi荞ݐײ
 *
 * 쌠 (c) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef PMIC_H
#define PMIC_H

#include <compiler.h>
#include <ccp.h>

/**
 * \defgroup pmic_groupݒ\ȑi荞ݐ
 *
 * \ref xmega_pmic_quickstart B
 *
 * AVR XMEGAݒ\ȑi荞ݐpײގłB
 *
 * \note ̊֐荞ݏٰ(ISR)ŎgpꍇAǂ̔ISRނ܂
 *       ͒ʊ荞ݗpISRނ͑삪񕪒fA֐Ă΂ԂɊ荞
 *       ֎~邱ƂmɂȂ΂Ȃ܂B
 * @{
 */

/**
 * \brief 荞 ޯĎՕ
 *
 * \note ́AႦ΁Aق܂͋֎~ꍇOR邩
 *       ܂B
 */
enum pmic_level {
	PMIC_LVL_LOW    = PMIC_LOLVLEN_bm,		//!< ʊ荞
	PMIC_LVL_MEDIUM = PMIC_MEDLVLEN_bm,		//!< ʊ荞
	PMIC_LVL_HIGH   = PMIC_HILVLEN_bm,		//!< ʊ荞
	/**
	 * \brief Օs荞
	 * \note ͋֎~邱Ƃł܂B
	 */
	PMIC_LVL_NMI    = PMIC_NMIEX_bp,
};

//! 荞޸ʒu
enum pmic_vector {
	PMIC_VEC_APPLICATION,		//!< p̈
	PMIC_VEC_BOOT,				//!< ްR[
	PMIC_NR_OF_VECTORS,			//!< 荞޸ʒu
};

//! 荞݌v
enum pmic_schedule {
	PMIC_SCH_FIXED_PRIORITY,	//!< AŒDv
	PMIC_SCH_ROUND_ROBIN,		//!< ׳݌v
	PMIC_NR_OF_SCHEDULES,		//!< 荞݌vĐ
};

/**
 * \brief PMIC
 *
 * p̈ɒuꂽ޸ƌŒDvőSĂ̊荞ق܂B
 */
static inline void pmic_init(void)
{
	PMIC.CTRL = PMIC_LVL_LOW | PMIC_LVL_MEDIUM |
			PMIC_LVL_HIGH;
}

/**
 * \brief w肵  \a level(s) Ŋ荞݂
 *
 * \param  level 銄荞
 */
static inline void pmic_enable_level(enum pmic_level level)
{
	Assert((level & PMIC_LVL_NMI));

	PMIC.CTRL |= level;
}

/**
 * \brief w肵  \a level(s) Ŋ荞݂֎~
 *
 * \param  level ֎~銄荞
 */
static inline void pmic_disable_level(enum pmic_level level)
{
	Assert((level & PMIC_LVL_NMI));

	PMIC.CTRL &= ~level;
}

/**
 * \brief w肵荞 \a level(s) 
 *
 * \param  level ׂ銄荞
 *
 * \return 荞قĂtrue
 */
static inline bool pmic_level_is_enabled(enum pmic_level level)
{
	Assert((level & PMIC_LVL_NMI));

	return PMIC.CTRL & level;
}

/**
 * \brief ݋Ăق擾
 *
 * \return ݋ĂقޯĎՕ
 */
static inline enum pmic_level pmic_get_enabled_levels(void)
{
	return (enum pmic_level)(PMIC.CTRL & (PMIC_LVL_LOW | PMIC_LVL_MEDIUM
				| PMIC_LVL_HIGH));
}

/**
 * \brief 荞قݎsĂ邩
 *
 * \param  level ׂ銄荞
 *
 * \return 荞قݎsĂtrue
 */
static inline bool pmic_level_is_executing(enum pmic_level level)
{
	return PMIC.STATUS & level;
}

/**
 * \brief ʊ荞݂ɑ΂Ċ荞݌vݒ
 *
 * \param  schedule ݒ肷銄荞݌v@
 *
 * \note D挠޸INTPRI͊芄荞ݗD揇ɖ߂߂׳݌v悪
 *       ~鎞0ɐݒ肳Ȃ΂Ȃ܂B
 */
static inline void pmic_set_scheduling(enum pmic_schedule schedule)
{
	Assert(schedule < PMIC_NR_OF_SCHEDULES);

	switch (schedule) {
	case PMIC_SCH_FIXED_PRIORITY:
		PMIC.CTRL &= ~PMIC_RREN_bm;
		PMIC.INTPRI = 0;
		break;

	case PMIC_SCH_ROUND_ROBIN:
		PMIC.CTRL |= PMIC_RREN_bm;
		break;

	default:
		break;
	};
}

/**
 * \brief 荞޸̈ʒuݒ
 *
 * \param  vector 荞޸pɎgpʒu
 */
static inline void pmic_set_vector_location(enum pmic_vector vector)
{
	uint8_t ctrl = PMIC.CTRL;

	Assert(vector < PMIC_NR_OF_VECTORS);

	switch (vector) {
	case PMIC_VEC_APPLICATION:
		ctrl &= ~PMIC_IVSEL_bm;
		break;

	case PMIC_VEC_BOOT:
		ctrl |= PMIC_IVSEL_bm;
		break;

	default:
		break;
	}

	ccp_write_io((uint8_t*)&PMIC.CTRL, ctrl);
}

//! @}

/**
 * \page xmega_pmic_quickstart PMICײޗpJn̎
 *
 * ͎gpʂ̑Iײނ`ԐݒƎgp̕@̒iKIȎw 
 * \ref pmic_group "PMICײ" ƖڂɊ֘A \ref interrupt_group "S̊
 * ײ"p̑Jn̎łB
 *
 * gpʂ͏̺ޒfЂ܂݂܂B\ݒpiK̺ޒfЂ͓Ǝ֐
 * ɕʂ邱ƂłAgpiK͗Ⴆ΁A剞p֐ɕʂ邱
 * ł܂B
 *
 * \section pmic_basic_use_case {IȎgp
 * ̊{IȎgpʂŁAPMIC͈ȉ̂悤Ɍ`Ԑݒ肳܂B
 * - SĂ̊荞ق
 * - ׳݌v
 *
 * ͎gp鑼̒Pʕ̊荞݂܂B
 *
 * \section pmic_basic_use_case_setup \ݒiK
 *
 * \subsection pmic_basic_use_case_setup_prereq OKv
 * ߂ɍ\ݒ躰ނɂāAۼުĂɈȉǉȂ΂Ȃ܂
 * B
 * -# PMICPʕKvƂPʕp荞݂Ȃ΂Ȃ܂B
 * -# ^ꂽ荞޸p̊荞ݏٰ(ISR)°݂ɂĒ`
 *    AްĂ'荞޸v'ňꗗɂ闘p\Ȋ荞޸
 *    `Ȃ΂Ȃ܂B 
 * \code
 *     ISR(interrupt_vector){
 *         // 荞ݏٰ
 *     }
 * \endcode
 *
 * \subsection pmic_basic_use_case_setup_code ޗ
 * ނɒǉ܂B
 * \code
 *     pmic_init();
 *     pmic_set_scheduling(PMIC_SCH_ROUND_ROBIN);
 *     cpu_irq_enable();
 * \endcode
 *
 * \subsection pmic_basic_use_case_setup_flow Ƃ̗
 * -# SĂق邽߂PMICײގg̏֐Ăт܂B
 *   - \code pmic_init(); \endcode
 * -# ŒD挠荞݌v̑׳݂܂B
 *   - \code pmic_set_scheduling(PMIC_SCH_ROUND_ROBIN); \endcode
 * -# 荞݂S̓Iɋ܂B
 *   - \code cpu_irq_enable(); \endcode
 *   - \attention 荞݂͂̒iKȂł͋N܂B
 *
 * \section pmic_use_cases xȎgp
 * ƍxPMICײނ̎gpʂɂĂ͈ȉ̎gpʂB
 * - \subpage pmic_use_case_1 : 񕪒f
 */

/**
 * \page pmic_use_case_1 gp#1
 *
 * ̎gpʂłPMICȉ̂悤Ɍ`Ԑݒ肳܂B
 * - S荞ً
 * 
 * ͎gpĂ鑼̒Pʕ̊荞݂܂B
 *
 * ̎gpʂ͊荞܂Ȃ߂琬鑀AA񕪒f@
 * ܂Bް荞ݏɂı꓾̂Ɠɑ̺ނ
 * 𱸾A̍Œ1ύX댯ꍇɂꂪxXKvłB
 *
 * \section pmic_use_case_1_setup \ݒiK
 *
 * \subsection pmic_basic_use_case_setup_prereq OKv
 * ߂ɂ̎gpʂɂāAۼުĂɈȉǉȂ΂Ȃ܂B
 * -# PMICPʕKvƂPʕp̊荞݂Ȃ΂Ȃ܂B
 * -# ^ꂽ荞޸p̊荞ݏٰ(ISR)°݂ɂĒ`
 *    AްĂ'荞޸v'ňꗗɂ闘p\Ȋ荞޸
 *    `Ȃ΂Ȃ܂B 
 * \code
 *     ISR(interrupt_vector){
 *         // 荞ݏٰ
 *     }
 * \endcode
 *
 * \subsection pmic_use_case_1_setup_code ޗ
 * pɒǉ܂B
 * \code
 *     pmic_init();
 *     cpu_irq_enable();
 * \endcode
 *
 * \subsection pmic_use_case_1_setup_flow Ƃ̗
 * -# SĂ̊荞ق邽߂PMICײގg̏֐Ăт܂B
 *   - \code pmic_init(); \endcode
 * -# S̊荞݋׸ނݒ肵܂B
 *   - \code cpu_irq_enable(); \endcode
 *
 * \section pmic_use_case_1_usage giK
 *
 * \subsection pmic_use_case_1_usage_code ޗ
 * \code
 * pɒǉ܂B
 * void atomic_operation(void)
 * {
 *     irqflags_t flags;
 *
 *     flags = cpu_irq_save();
 *
 *     // 荞܂Ȃ̺
 *
 *     cpu_irq_restore(flags);
 * }
 * \endcode
 *
 * \subsection pmic_use_case_1_usage_flow Ƃ̗
 * -# 荞݋pꎞL蓖
 *   - \code irqflags_t flags; \endcode
 * -# ȌԂۑԁAS̊荞݋׸ނ
 *   - \code flags = cpu_irq_save(); \endcode
 * -# ɑS̊荞݋׸ނȌԂɕ
 *   - \code cpu_irq_restore(flags); \endcode
 */

#endif /* PMIC_H */
