/**
 * \file
 *
 * \brief 8/32ޯAVRpS̊荞݊Ǘ
 *
 * 쌠 (c) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef UTILS_INTERRUPT_H
#define UTILS_INTERRUPT_H

#include <parts.h>

#if XMEGA || MEGA || TINY
#  include "interrupt/interrupt_avr8.h"
#elif UC3
#  include "interrupt/interrupt_avr32.h"
#elif SAM3S || SAM3N || SAM3XA || SAM3U || SAM4S || SAM4L || SAM4E
#  include "interrupt/interrupt_sam_nvic.h"
#else
#  error Unsupported device.
#endif

/**
 * \defgroup interrupt_group S̊荞݊Ǘ
 *
 * ͊荞݂̑S̓IȋƋ֎~pײނłB
 *
 * @{
 */

#if defined(__DOXYGEN__)
/**
 * \def CONFIG_INTERRUPT_FORCE_INTC
 * \brief ASF INTCײނ̎gp
 *
 * ASF INTCײނ̎gp邽߂ɑOɂ̼قO`܂B
 * ͺׂ߲𱸾݊Ɖp̋߂ɂĕKvƂ鎞gp邱
 * Ƃۏ؂̂ɗLpłB
 */
#  define CONFIG_INTERRUPT_FORCE_INTC
#endif

//! \name S̊荞׸
//@{
/**
 * \typedef irqflags_t
 * \brief 荞׸ނ̏Ԃێ̂Ɏgp^
 */

/**
 * \def cpu_irq_enable
 * \brief S̓IɊ荞݂
 */

/**
 * \def cpu_irq_disable
 * \brief S̓IɊ荞݂֎~
 */

/**
 * \fn irqflags_t cpu_irq_save(void)
 * \brief S̊荞׸ނ擾ĉ
 *
 * \ref cpu_irq_restore ƕĎgpĂB
 *
 * \return 荞׸ނ݂̌̏
 *
 * \note ̊֐͊荞݂֎~ꂽ܂܂ɂ܂B
 */

/**
 * \fn void cpu_irq_restore(irqflags_t flags)
 * \brief S̊荞׸ނ
 *
 * \ref cpu_irq_save ƕĎgpĂB
 *
 * \param  flags 荞׸ނɐݒ肳ꂽ
 */

/**
 * \fn bool cpu_irq_is_enabled_flags(irqflags_t flags)
 * \brief ꂽ׸ނŊ荞݂S̓IɋĂ邩𒲍
 *
 * \param  flags 荞׸ނ݂̌̏
 *
 * \return True 荞݂Ăꍇ
 */

/**
 * \def cpu_irq_is_enabled
 * \brief 荞݂S̓IɋĂ邩𒲍
 *
 * \return True 荞݂Ăꍇ
 */
//@}

//! @}

/**
 * \ingroup interrupt_group
 * \defgroup interrupt_deprecated_group dꂽ荞ݒ`
 */

#endif /* UTILS_INTERRUPT_H */
