/**
 * \file
 *
 * \brief sؐײ
 *
 * 쌠 (C) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "compiler.h"
#include "ccp.h"
#include "nvm.h"
#include <string.h>

/**
 * \weakgroup nvm_signature_group
 * @{
 */

/**
 * \brief ޲ʔԓǂݍ
 *
 * ̊֐޲Ɋi[ꂽ޲ʔԂԂ܂B
 *
 * \note ̊֐NVM.CMDڼ޽ύX܂Bp荞݂۸ыԱ(IAR
 *        EWł__flashʒuwq܂GCCłpgm_read_byte)gpꍇA
 *       荞݂EEPROM֐𑖂点鎞ɋ֎~邱ƂKvłB
 *       ΁A۸ыԓǂݍ݂͕sɂ܂B
 *
 * \retval storage ޲ʔԂi[邽߂̍\̂ւ̈ʒuwq
 */
void nvm_read_device_serial(struct nvm_device_serial *storage)
{
	storage->lotnum0 = nvm_read_production_signature_row(
			nvm_get_production_signature_row_offset(LOTNUM0));
	storage->lotnum1 = nvm_read_production_signature_row(
			nvm_get_production_signature_row_offset(LOTNUM1));
	storage->lotnum2 = nvm_read_production_signature_row(
			nvm_get_production_signature_row_offset(LOTNUM2));
	storage->lotnum3 = nvm_read_production_signature_row(
			nvm_get_production_signature_row_offset(LOTNUM3));
	storage->lotnum4 = nvm_read_production_signature_row(
			nvm_get_production_signature_row_offset(LOTNUM4));
	storage->lotnum5 = nvm_read_production_signature_row(
			nvm_get_production_signature_row_offset(LOTNUM5));

	storage->wafnum  = nvm_read_production_signature_row(
			nvm_get_production_signature_row_offset(WAFNUM));

	storage->coordx0 = nvm_read_production_signature_row(
			nvm_get_production_signature_row_offset(COORDX0));
	storage->coordx1 = nvm_read_production_signature_row(
			nvm_get_production_signature_row_offset(COORDX1));
	storage->coordy0 = nvm_read_production_signature_row(
			nvm_get_production_signature_row_offset(COORDY0));
	storage->coordy1 = nvm_read_production_signature_row(
			nvm_get_production_signature_row_offset(COORDY1));
}

//! @}

/**
 * \weakgroup nvm_eeprom_group
 * @{
 */

/**
 * \brief ؊蓖ıpEEPROM1޲ēǂݍ
 *
 * ̊֐؊蓖ıpEEPROM1޲Ăǂ݂܂B
 *
 * \param  addr 0`EEPROM̑傫܂łEEPROMڽ
 *
 * \return EEPROMǂ޲Ēl
 */
uint8_t nvm_eeprom_read_byte(eeprom_addr_t addr)
{
	uint8_t data;
	Assert(addr <= EEPROM_SIZE);

	/* NVM܂őҋ@ */
	nvm_wait_until_ready();
	eeprom_enable_mapping();
	data = *(uint8_t*)(addr + MAPPED_EEPROM_START),
	eeprom_disable_mapping();
	return data;
}

/**
 * \brief EEPROMɏՕ֓ǂݍ
 *
 * \param  address ǂޏꏊ̱ڽ
 * \param  buf     ްւ̈ʒuwq
 * \param  len     ǂ޲Đ
 */
void nvm_eeprom_read_buffer(eeprom_addr_t address, void *buf, uint16_t len)
{
	nvm_wait_until_ready();
	eeprom_enable_mapping();
	memcpy( buf,(void*)(address+MAPPED_EEPROM_START), len );
	eeprom_disable_mapping();
}

/**
 * \brief I/O蓖ĂpEEPROM1޲ď
 *
 * ̊֐I/O蓖ıpEEPROM1޲Ă܂B̊֐́A
 * ΁Ais̑SĂEEPROM߰ފɏՕݒ葀܂B
 *
 * \param  address EEPROMڽ(őEEPROM_SIZE)
 * \param  value   EEPORM֏޲Ēl
 */
void nvm_eeprom_write_byte(eeprom_addr_t address, uint8_t value)
{
	uint8_t old_cmd;

	Assert(address <= EEPROM_SIZE);
	/*  \ްȂƂۏ؂邽߂ɊɏՕjĎwڼ޽
	 *  "߰ސݒ"w߂ݒ肵܂B
	 */
	old_cmd = NVM.CMD;
	nvm_eeprom_flush_buffer();
	// NVM܂őҋ@
	nvm_wait_until_ready();
	nvm_eeprom_load_byte_to_buffer(address, value);

	// ڽݒ
	NVM.ADDR2 = 0x00;
	NVM.ADDR1 = (address >> 8) & 0xFF;
	NVM.ADDR0 = address & 0xFF;

	/*  EEPROM񕪒f(&)w߂𔭍sBwߐݒAی쎯[݁Aw
	 *  s
	 */
	NVM.CMD = NVM_CMD_ERASE_WRITE_EEPROM_PAGE_gc;
	nvm_exec();
	NVM.CMD = old_cmd;
}

/**
 * \brief EEPROM֊ɏՕ
 *
 * \param  address ꏊ̱ڽ
 * \param  buf     ް̈ʒuwq
 * \param  len     ޲Đ
 */
void nvm_eeprom_erase_and_write_buffer(eeprom_addr_t address, const void *buf, uint16_t len)
{
	while (len) {
		if (((address%EEPROM_PAGE_SIZE)==0) && (len>=EEPROM_PAGE_SIZE)) {
			// S߰ނ꓾܂B
			nvm_eeprom_load_page_to_buffer((uint8_t*)buf);
			nvm_eeprom_atomic_write_page(address/EEPROM_PAGE_SIZE);
			address += EEPROM_PAGE_SIZE;
			buf = (uint8_t*)buf + EEPROM_PAGE_SIZE;
			len -= EEPROM_PAGE_SIZE;
		} else {
			nvm_eeprom_write_byte(address++, *(uint8_t*)buf);
			buf = (uint8_t*)buf + 1;
			len--;
		}
	}
}

/**
 * \brief ꎞEEPORM߰ފɏՕp
 *
 * ̊֐EEPROM߰ފɏՕj܂B̊֐́A΁Aǂ̐is
 * EEPROM߰ފɏՕݒ葀܂B̊֐؊蓖EEPROM
 * ܂B
 *
 * \note EEPROMݑ͂Ȃ̂߂ɎIɊɏՕj܂B
 * \note ̊֐NVM.CMDڼ޽̒lی삵܂B
 */
void nvm_eeprom_flush_buffer(void)
{
	// NVM܂őҋ@
	nvm_wait_until_ready();

	// KvȂ΁AEEPROM߰ފɏՕj
	if ((NVM.STATUS & NVM_EELOAD_bm) != 0) {
		NVM.CMD = NVM_CMD_ERASE_EEPROM_BUFFER_gc;
		nvm_exec();
	}
}

/**
 * \brief ꎞ߰ފɏՕɒP޲Đݒ
 *
 * ̊֐͈ꎞEEPROM߰ފɏՕ1޲Ăݒ肵܂B؊蓖EEPROM
 * ꍇÅ֐͓܂B޲ĐݒJnOɊɏՕjĂ
 * 邱ƂmɂĂB܂Aʒuɕ޲Ăݒ肳ꂽꍇA
 * ͋ANDÂ0x550xAA͊ɏՕ0x00ɋA܂B
 *
 * \note 1߰ފɏՕ݂Â1߰ންݒ肵1
 *       ߰ނɏƂł܂BްႤ߰ނɏ邱ƂKvȂA
 *       Ə݂JԂ邱ƂKvłB
 *
 * \param  byte_addr 0`EEPROM_PAGE_SIZE܂łEEPROM޲ ڽ
 * \param  value     ɏՕɏ޲Ēl
 */
void nvm_eeprom_load_byte_to_buffer(uint8_t byte_addr, uint8_t value)
{
	// NVM܂őҋ@
	nvm_wait_until_ready();

	eeprom_enable_mapping();
	*(uint8_t*)(byte_addr + MAPPED_EEPROM_START) = value;
	eeprom_disable_mapping();
}

/**
 * \brief ߰ޑŜꎞEEPROM߰ފɏՕɐݒ
 *
 * ̊֐SRAMɏՕEEPROM߰ފɏՕEEPROM߰ޑŜݒ肵܂B
 * 蓖EEPROMꍇÅ֐͓܂B޲ĐݒJnO
 * ɏՕj邱ƂmɂĂB
 *
 * \note ɏՕ̱ڽwɱڽ̉ʑgp܂B]āAڽ 
 *       Ұ͑SKvƂ܂BŌŁAEEPROM߰ޑ̂߂ɱ
 *       ڽ Ұɂė^ꂽEEPROM߰ން܂B
 *
 * \param  values ߰ޑŜ܂SRAMɏՕւ̈ʒuwq
 */
void nvm_eeprom_load_page_to_buffer(const uint8_t *values)
{
	// NVM܂őҋ@
	nvm_wait_until_ready();

	// ߰ފɏՕ֕޲Đݒ
	uint8_t i;
	for (i = 0; i < EEPROM_PAGE_SIZE; ++i) {
		nvm_eeprom_load_byte_to_buffer(i, *values);
		++values;
	}
}

/**
 * \brief ߰ފɏՕ޲ĂEEPROM֏Ə
 *
 * ̊֐͊ɐݒ肳ꂽEEPROM߰ފɏՕ̓lEEPROMɏ܂B
 *
 * ꂪ񕪒f݂̂߁AEEPROM߰ނ͏OɎIɏ܂B
 * ݒ肳ꂽ߰ފɏՕ̈ʒuEEPROMݎɎgp܂Bݒ肳
 * ߰ފɏՕ̈ʒuEEPROMŎt̂܂܂ɂ܂B
 *
 * \param  page_addr 0`EEPROM_SIZE/EEPROM_PAGE_SIZEԂEEPROM߰ ڽ
 */
void nvm_eeprom_atomic_write_page(uint8_t page_addr)
{
	// NVM܂őҋ@
	nvm_wait_until_ready();

	// ߰ ڽvZ
	uint16_t address = (uint16_t)(page_addr * EEPROM_PAGE_SIZE);

	Assert(address <= EEPROM_SIZE);

	// ڽݒ
	NVM.ADDR2 = 0x00;
	NVM.ADDR1 = (address >> 8) & 0xFF;
	NVM.ADDR0 = address & 0xFF;

	// EEPROM񕪒f(&)wߔs
	nvm_issue_command(NVM_CMD_ERASE_WRITE_EEPROM_PAGE_gc);
}

/**
 * \brief (Ȃ)EEPROM߰ޏ
 *
 * ̊֐͊ɐݒ肳ꂽEEPROM߰ފɏՕ̓eEEPROMɏ܂B
 *
 * ꂪ݂̂߁AEEPROM߰ނ͏ݑOɏ܂B
 *
 * \param  page_addr 0`EEPROM_SIZE/EEPROM_PAGE_SIZEԂEEPROM߰ ڽ
 */
void nvm_eeprom_split_write_page(uint8_t page_addr)
{
	// NVM܂őҋ@
	nvm_wait_until_ready();

	// ߰ ڽvZ
	uint16_t address = (uint16_t)(page_addr * EEPROM_PAGE_SIZE);

	Assert(address <= EEPROM_SIZE);

	// ڽݒ
	NVM.ADDR2 = 0x00;
	NVM.ADDR1 = (address >> 8) & 0xFF;
	NVM.ADDR0 = address & 0xFF;

	// EEPROMݎwߔs
	nvm_issue_command(NVM_CMD_WRITE_EEPROM_PAGE_gc);
}

/**
 * \brief lňꎞEEPROM߰ފɏՕ𖞂B
 *
 * ̊֐͗^ꂽlEEPROM߰ފɏՕ𖞂܂B؊蓖EEPROM
 * ꍇÅ֐͓܂B
 *
 * \note ɏՕ̱ڽwɱڽ̉ʑgp܂B]āAڽ 
 *       Ұ͑SKvƂ܂BŌŁAEEPROM߰ޑ̂߂ɱ
 *       ڽ Ұɂė^ꂽEEPROM߰ން܂B
 *
 * \param  value ߰ފɏՕɕʂl
 */
void nvm_eeprom_fill_buffer_with_value(uint8_t value)
{
	nvm_eeprom_flush_buffer();
	// NVM܂őҋ@
	nvm_wait_until_ready();
	// ߰ފɏՕɕ޲Đݒ
	uint8_t i;
	for (i = 0; i < EEPROM_PAGE_SIZE; ++i) {
		nvm_eeprom_load_byte_to_buffer(i, value);
	}
}

/**
 * \brief EEPROM߰ނ޲ď
 *
 * ̊֐1EEPROM߰ނ޲ĂÂ߰ފɏՕɏSĂ
 * ʒu0xFFǂ݂܂B
 *
 * \param  page_addr 0`EEPROM_SIZE/EEPROM_PAGE_SIZEԂEEPROM߰ ڽ
 */
void nvm_eeprom_erase_bytes_in_page(uint8_t page_addr)
{
	// NVM܂őҋ@
	nvm_wait_until_ready();

	// ߰ ڽvZ
	uint16_t address = (uint16_t)(page_addr * EEPROM_PAGE_SIZE);

	Assert(address <= EEPROM_SIZE);

	// ڽݒ
	NVM.ADDR2 = 0x00;
	NVM.ADDR1 = (address >> 8) & 0xFF;
	NVM.ADDR0 = address & 0xFF;

	// EEPROMwߔs
	nvm_issue_command(NVM_CMD_ERASE_EEPROM_PAGE_gc);
}

/**
 * \brief EEPROM߰ޏ
 *
 * ̊֐͑SĂ̈ʒu0xFFǂނ悤1EEPROM߰ނ܂B
 *
 * \param  page_addr 0`EEPROM_SIZE/EEPROM_PAGE_SIZEԂEEPROM߰ ڽ
 */
void nvm_eeprom_erase_page(uint8_t page_addr)
{
	// 폜SڽLB
	nvm_eeprom_fill_buffer_with_value(0xff);
	// ߰ޓS޲ď
	nvm_eeprom_erase_bytes_in_page(page_addr);
}


/**
 * \brief SEEPROM߰ނ޲Ă
 *
 * ̊֐߰ފɏՕɏSĂ̈ʒu0xFFǂނ悤ɑSĂEEPROM߰
 * ޲Ă܂B
 */
void nvm_eeprom_erase_bytes_in_all_pages(void)
{
	// NVM܂őҋ@
	nvm_wait_until_ready();

	// EEPROMSwߔs
	nvm_issue_command(NVM_CMD_ERASE_EEPROM_gc);
}

/**
 * \brief EEPROMS̏
 *
 * ̊֐EEPROMŜ0xFFɏ܂B
 */
void nvm_eeprom_erase_all(void)
{
	// 폜SڽLB
	nvm_eeprom_fill_buffer_with_value(0xff);
	// S߰ޏ
	nvm_eeprom_erase_bytes_in_all_pages();
}

//! @}


//! @}


/**
 * \weakgroup nvm_flash_group
 * @{
 */

/**
 * \brief ׯ͈CRCwߔs
 *
 * ̊֐NVM.CMDڼ޽ׯ͈CRCw߂ݒ肵܂B̌CRC-32𐶐
 * ׯ̊JnƏI޲ ڽADDRDATAڼ޽ɐݒ肵AŌɎwߎ
 * ss܂B
 *
 * \note CRCPʕ炾Ă΂ׂłB֐NVM.CMDڼ޽ۑĕ
 *       ܂Å֐荞݂Ă΂ꂽꍇÅ֐Ă΂OɊ
 *       ݂֎~Ȃ΂Ȃ܂B
 *
 * \param  start_addr I޲ ڽ
 * \param  end_addr   Jn޲ ڽ
 */
void nvm_issue_flash_range_crc(flash_addr_t start_addr, flash_addr_t end_addr)
{
	uint8_t old_cmd;
	// ݂NVMw߂ۑ
	old_cmd = NVM.CMD;

	// ׯ͈CRCw߂NVM.CMDڼ޽ɐݒ
	NVM.CMD = NVM_CMD_FLASH_RANGE_CRC_gc;

	// NVMڽ ڼ޽ɊJn޲ ڽݒ
	NVM.ADDR0 = start_addr & 0xFF;
	NVM.ADDR1 = (start_addr >> 8) & 0xFF;
#if (FLASH_SIZE >= 0x10000UL)
	NVM.ADDR2 = (start_addr >> 16) & 0xFF;
#endif

	// NVMް ڼ޽ɏI޲ ڽݒ
	NVM.DATA0 = end_addr & 0xFF;
	NVM.DATA1 = (end_addr >> 8) & 0xFF;
#if (FLASH_SIZE >= 0x10000UL)
	NVM.DATA2 = (end_addr >> 16) & 0xFF;
#endif

	// wߎs
	ccp_write_io((uint8_t *)&NVM.CTRLA, NVM_CMDEX_bm);

	// wڼ޽
	NVM.CMD = old_cmd;
}

/**
 * \brief p̈̊ɏՕǂݍ
 *
 * \param  address ǂޏꏊ̱ڽ
 * \param  buf     ްւ̈ʒuwq
 * \param  len     ǂ޲Đ
 */
void nvm_flash_read_buffer(flash_addr_t address, void *buf, uint16_t len)
{
#if (FLASH_SIZE>0x10000)
	uint32_t opt_address = address;
#else
	uint16_t opt_address = (uint16_t)address;
#endif
	nvm_wait_until_ready();
	while ( len ) {
		*(uint8_t*)buf = nvm_flash_read_byte(opt_address);
		buf=(uint8_t*)buf+1;
		opt_address++;
		len--;
	}
}

/**
 * \brief gpҗ̈̊ɏՕǂݍ
 *
 * \param  address ǂޏꏊ̱ڽ
 * \param  buf     ްւ̈ʒuwq
 * \param  len     ǂ޲Đ
 */
void nvm_user_sig_read_buffer(flash_addr_t address, void *buf, uint16_t len)
{
	uint16_t opt_address = (uint16_t)address&(FLASH_PAGE_SIZE-1);
	while ( len ) {
		*(uint8_t*)buf = nvm_read_user_signature_row(opt_address);
		buf=(uint8_t*)buf+1;
		opt_address++;
		len--;
	}
}

/**
 * \brief gpׯ̈̓蕔ɏ
 *
 * \param  address       ꏊ̱ڽ
 * \param  buf           ްւ̈ʒuwq
 * \param  len           ޲Đ
 * \param  b_blank_check trueȂ珑ݑsOׯ ߰ނA
 *                       Ȃ߰ޏw߂s
 *
 * ̑OɉpׯĂꍇb_blank_checkfalseɐݒ肵܂B
 */
void nvm_user_sig_write_buffer(flash_addr_t address, const void *buf,
	uint16_t len, bool b_blank_check)
{
	uint16_t w_value;
	uint16_t page_pos;
	uint16_t opt_address = (uint16_t)address;
	bool b_flag_erase = false;

	while ( len ) {
		for (page_pos=0; page_pos<FLASH_PAGE_SIZE; page_pos+=2 ) {
			if (b_blank_check) {
				// w߂K{m邽߂ׯǂ
				LSB(w_value) = nvm_read_user_signature_row(page_pos);
				MSB(w_value) = nvm_read_user_signature_row(page_pos+1);
				if (w_value!=0xFFFF) {
					b_flag_erase = true;	// ߰ނ͋łȂ
				}
			}else{
				w_value = 0xFFFF;
			}
			// ׯɏՕXV
			if (len) {
				if (opt_address == page_pos) {
					// ڽ̂߁Aׯ̏޲ĂύXȂ΂
					// ܂B
					len--;
					opt_address++;
					LSB(w_value)=*(uint8_t*)buf;
					buf=(uint8_t*)buf+1;
				}
			}
			if (len) {
				if (opt_address == (page_pos+1)) {
					// gpҊɏՕłȂ߁Aׯ̉޲ĂύX
					// Ȃ΂Ȃ܂B
					len--;
					opt_address++;
					MSB(w_value)=*(uint8_t*)buf;
					buf=(uint8_t*)buf+1;
				}
			}
			// ׯɏՕݒ
			nvm_flash_load_word_to_buffer(page_pos,w_value);
		}
	}
	// ׯɏՕ
	if (b_flag_erase) {
		nvm_flash_erase_user_section();
	}
	nvm_flash_write_user_page();
}

/**
 * \brief ĉpׯ̈̓蕔
 *
 * \param  address       ꏊ̱ڽ
 * \param  buf           ްւ̈ʒuwq
 * \param  len           ޲Đ
 * \param  b_blank_check trueȂ珑ݑsOׯ ߰ނA
 *                       Ȃ߰ޏw߂s
 *
 * ̑OɉpׯĂꍇb_blank_checkfalseɐݒ肵܂B
 */
void nvm_flash_erase_and_write_buffer(flash_addr_t address, const void *buf,
	uint16_t len, bool b_blank_check)
{
	uint16_t w_value;
	uint16_t page_pos;
	bool b_flag_erase;
#if (FLASH_SIZE>0x10000)
	uint32_t page_address;
	uint32_t opt_address = address;
#else
	uint16_t page_address;
	uint16_t opt_address = (uint16_t)address;
#endif

	// ύX߰ނ̐擪vZ
	page_address = opt_address-(opt_address%FLASH_PAGE_SIZE);

	// e߰ނɑ΂
	while ( len ) {
		b_flag_erase = false;

		nvm_wait_until_ready();
		for (page_pos=0; page_pos<FLASH_PAGE_SIZE; page_pos+=2 ) {
			if (b_blank_check) {
				// w߂K{m邽߂ׯǂ
				w_value = nvm_flash_read_word(page_address);
				if (w_value!=0xFFFF) {
					b_flag_erase = true;	// ߰ނ͋łȂ
				}
			}else{
				w_value = 0xFFFF;
			}

			// ׯɏՕXV
			if (len) {
				if (opt_address == page_address) {
					// ڽ̂߁Aׯ̏޲ĂύXȂ΂
					// ܂B
					len--;
					opt_address++;
					LSB(w_value)=*(uint8_t*)buf;
					buf=(uint8_t*)buf+1;
				}
			}
			if (len) {
				if (opt_address == (page_address+1)) {
					// gpҊɏՕłȂ߁Aׯ̉޲ĂύX
					// Ȃ΂Ȃ܂B
					len--;
					opt_address++;
					MSB(w_value)=*(uint8_t*)buf;
					buf=(uint8_t*)buf+1;
				}
			}
			// ׯɏՕݒ
			nvm_flash_load_word_to_buffer(page_address,w_value);
			page_address+=2;
		}

		// ׯɏՕ
		if (b_flag_erase) {
			nvm_flash_atomic_write_app_page(page_address-FLASH_PAGE_SIZE);
		}else{
			nvm_flash_split_write_app_page(page_address-FLASH_PAGE_SIZE);
		}
	}
}

//! @}

/**
 * \weakgroup nvm_fuse_lock_group
 * @{
 */

/**
 * \brief ˭ ޲ēǂݍ
 *
 * ̊֐͗^ꂽ˭ ޲Ă̒lǂŕԂ܂B
 *
 * \param  fuse ǂ˭ ޲
 *
 * \return ˭ނ޲Ēl
 */
uint8_t nvm_fuses_read(enum fuse_byte_t fuse)
{
	// NVM܂őҋ@
	nvm_wait_until_ready();

	// ڽݒ
	NVM.ADDR0 = fuse;

	// READ_FUSESwߔs
	nvm_issue_command(NVM_CMD_READ_FUSES_gc);

	return NVM.DATA0;
}

//! @}
