/**
 * \file
 *
 * \brief AVR XMEGA/4܂5(TC4/5)ײ
 *
 * 쌠 (c) 2012-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef TC45_H
#define TC45_H

#include "asf.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
 * XMEGA IARͯ ُ̧C
 */
#if defined(__IAR_SYSTEMS_ICC__)
/* QA~I */
typedef enum FAULT_HALTA_enum {
	FAULT_HALTA_DISABLE_gc = (0x00 << 5),	/*< ~֎~ */
	FAULT_HALTA_HW_gc = (0x01 << 5),		/*< ʰ޳~ */
	FAULT_HALTA_SW_gc = (0x02 << 5),		/*< ĳ~ */
} FAULT_HALTA_t;

/* QB~I */
typedef enum FAULT_HALTB_enum {
	FAULT_HALTB_DISABLE_gc = (0x00 << 5),	/*< ~֎~ */
	FAULT_HALTB_HW_gc = (0x01 << 5),		/*< ʰ޳~ */
	FAULT_HALTB_SW_gc = (0x02 << 5),		/*< ĳ~ */
} FAULT_HALTB_t;

/* َwWw */
typedef enum FAULT_IDXCMD_enum {
	FAULT_IDXCMD_DISABLE_gc = (0x00 << 3),	/*< wߋ֎~ */
	FAULT_IDXCMD_SET_gc = (0x01 << 3),		/*< ̎ŎB */
	FAULT_IDXCMD_CLEAR_gc = (0x02 << 3),	/*< ̎ŎA */
	FAULT_IDXCMD_HOLD_gc = (0x03 << 3),		/*< ̎Ō݂̎wWێ */
} FAULT_IDXCMD_t;

/* sȒl܂IAREW V6.12C */
#undef TC45_WGMODE_SINGLESLOPE_gc
#undef TC45_WGMODE_DSTOP_gc
#define TC45_WGMODE_SINGLESLOPE_gc (0x03<<0)	/* PX */
#define TC45_WGMODE_DSTOP_gc       (0x05<<0)	/* 2dX΁ATOPōXV */

#endif

/**
 * \defgroup tc45_group /4/5^(TC4/5)
 *
 * \ref xmega_tc45_quickstart B
 *
 * AVR XMEGA/4^5^(TC4/5)pײނłBTC4/5Pʕ̋A
 * ~A`Ԑݒ肷邽߂̊֐񋟂܂B
 *
 * \section dependencies ˑ
 * ײނ͈ȉ̒PʕɈˑ܂B
 * - Ӹۯp \ref sysclk_group
 * - ꂽx~ݒ肷邽߂ \ref sleepmgr_group
 * - ISR`ƏdvȺޗ̈̊ԂŊ荞݂֎~邽߂ \ref interrupt_group
 * @{
 */

/**
 * \brief ݎیĂі߂֐^
 *
 * 荞ݏ͊֐Ăі߂s悤Ɍ`Ԑݒ肷邱ƂłAĂі߂֐
 * tc45_callback_t^ɍvȂ΂Ȃ܂B
 *
 */
typedef void (*tc45_callback_t)(void);

/* ! /r/ߊlَwW */
enum tc45_cc_channel_t {
	TC45_CCA = 1,	/* !< A */
	TC45_CCB = 2,	/* !< B */
	TC45_CCC = 3,	/* !< C */
	TC45_CCD = 4,	/* !< D */
};

/* ! /r/ߊlٓwW */
enum tc45_cc_channel_mask_enable_t {
	TC45_CCACOMP = TC45_CCAMODE_COMP_gc,	/* !< AՕ */
	TC45_CCACAPT = TC45_CCAMODE_CAPT_gc,
	TC45_CCBCOMP = TC45_CCBMODE_COMP_gc,	/* !< BՕ */
	TC45_CCBCAPT = TC45_CCCMODE_CAPT_gc,
	TC45_CCCCOMP = TC45_CCCMODE_COMP_gc,	/* !< CՕ */
	TC45_CCCCAPT = TC45_CCCMODE_CAPT_gc,
	TC45_CCDCOMP = TC45_CCDMODE_COMP_gc,	/* !< DՕ */
	TC45_CCDCAPT = TC45_CCDMODE_CAPT_gc,
};

/* ! / */
enum tc45_dir_t {
	TC45_UP = 0,	/* !< ㏸v */
	TC45_DOWN = 1	/* !< ~v */
};

/* ! /g` */
enum tc45_wg_mode_t {
	TC45_WG_NORMAL = TC45_WGMODE_NORMAL_gc,		/* !< WłTC45 */
	TC45_WG_FRQ = TC45_WGMODE_FRQ_gc,			/* !< g퓮łTC45 */
	TC45_WG_SS = TC45_WGMODE_SINGLESLOPE_gc,	/* !< PXPWMłTC45 */
	TC45_WG_DS_T = TC45_WGMODE_DSTOP_gc,		/* !< 2dXΒPWMłTC45 */
	TC45_WG_DS_TB = TC45_WGMODE_DSBOTH_gc,		/* !< 2dXΗPWMłTC45 */
	TC45_WG_DS_B = TC45_WGMODE_DSBOTTOM_gc		/* !< 2dXΒPWMłTC45 */
};

/* ! QAI */
enum fault_sourceA_mode_t {
	FAULT_SRCA_DEFAULT = FAULT_SRCA_DISABLE_gc,	/* !< WłOTMX */
	FAULT_SRCA_N = FAULT_SRCA_CHN_gc,			/* !< WłOTMX */
	FAULT_SRCA_N1 = FAULT_SRCA_CHN1_gc,			/* !< WłOTMX */
	FAULT_SRCA_NB = FAULT_SRCA_LINK_gc,			/* !< WłOTMX */
};

/* ! QBI */
enum fault_sourceB_mode_t {
	FAULT_SRCB_DEFAULT = FAULT_SRCB_DISABLE_gc,	/* !< WłOTMX */
	FAULT_SRCB_N = FAULT_SRCB_CHN_gc,			/* !< WłOTMX */
	FAULT_SRCB_N1 = FAULT_SRCB_CHN1_gc,			/* !< WłOTMX */
	FAULT_SRCB_NB = FAULT_SRCB_LINK_gc,			/* !< WłOTMX */
};

/* ! QEI */
enum fault_sourceE_mode_t {
	FAULT_SRCE_DEFAULT = FAULT_SRCE_DISABLE_gc,	/* !< WłOTMX */
	FAULT_SRCE_N = FAULT_SRCE_CHN_gc,			/* !< WłOTMX */
	FAULT_SRCE_N1 = FAULT_SRCE_CHN1_gc,			/* !< WłOTMX */
	FAULT_SRCE_N2 = FAULT_SRCE_CHN2_gc,			/* !< WłOTMX */
};

/* ! Q~AI */
enum fault_haltA_mode_t {
	FAULT_HALTA_DEFAULT = FAULT_HALTA_DISABLE_gc,	/* !< WłOTMX */
	FAULT_HALTA_HW = FAULT_HALTA_HW_gc,				/* !< WłOTMX */
	FAULT_HALTA_SW = FAULT_HALTA_SW_gc,				/* !< WłOTMX */
};

/* ! Q~BI */
enum fault_haltB_mode_t {
	FAULT_HALTB_DEFAULT = FAULT_HALTB_DISABLE_gc,	/* !< WłOTMX */
	FAULT_HALTB_HW = FAULT_HALTB_HW_gc,				/* !< WłOTMX */
	FAULT_HALTB_SW = FAULT_HALTB_SW_gc,				/* !< WłOTMX */
};

/* ! g`go͔z񓮍 */
enum wex_otmx_mode_t {
	WEX_OTMX_DEFAULT = WEX_OTMX_DEFAULT_gc,	/* !< WłOTMX */
	WEX_OTMX_1 = WEX_OTMX_FIRST_gc,			/* !< WłOTMX */
	WEX_OTMX_2 = WEX_OTMX_SECOND_gc,		/* !< WłOTMX */
	WEX_OTMX_3 = WEX_OTMX_THIRD_gc,			/* !< WłOTMX */
	WEX_OTMX_4 = WEX_OTMX_FOURTH_gc,		/* !< WłOTMX */
};

/* ! TC45荞 */
enum TC45_INT_LEVEL_t {
	TC45_INT_LVL_OFF = 0x00,
	TC45_INT_LVL_LO = 0x01,
	TC45_INT_LVL_MED = 0x02,
	TC45_INT_LVL_HI = 0x03,
};

/* ! nꂽTC45̌^TC5_tϸ */
#define tc45_is_TC5(void) ((uint16_t)tc & 0x40 ? true : false)
/* ! nꂽTC45̌^TC4_tϸ */
#define tc45_is_TC4(void) ((uint16_t)tc & 0x40 ? false : true)

/**
 * \brief TC45
 *
 * TC45܂B
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note TC45ۯ(sysclk)Օ܂񂪁ATC45ۯ`Ԑݒ肵܂B
 */
void tc45_enable(volatile void *tc);

/**
 * \brief TC45֎~
 *
 * TC45֎~܂B
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note TC45ۯ(sysclk)Օ܂B
 */
void tc45_disable(volatile void *tc);

/**
 * \ingroup tc45_group
 * \defgroup tc45_interrupt_group /(TC45)荞݊Ǘ
 *
 * ̌QTC45Pʕ荞݂`Ԑݒ肷֐񋟂܂B
 *
 * @{
 */

/**
 * \brief TC45ꊄ荞݌Ăі߂֐ݒ
 *
 * ̊֐͊荞݌Ăі߂֐ݒ肵ĕύX邱ƂĂяoɋ܂B
 * Ăі߂֐̐ݒȂłײޓ̊荞ݏ荞ݗv׸ނ
 * ܂B
 *
 * \param  tc       /(TC45)ڽւ̈ʒuwq
 * \param  callback Ăі߂֐ւ̎QƊ
 */
void tc45_set_overflow_interrupt_callback(volatile void *tc,
		tc45_callback_t callback);

/**
 * \brief TC45ُ튄荞݌Ăі߂֐ݒ
 *
 * ̊֐͊荞݌Ăі߂֐ݒ肵ĕύX邱ƂĂяoɋ܂B
 * Ăі߂֐̐ݒȂłײޓ̊荞ݏ荞ݗv׸ނ
 * ܂B
 *
 * \param  tc       /(TC45)ڽւ̈ʒuwq
 * \param  callback Ăі߂֐ւ̎QƊ
 */
void tc45_set_error_interrupt_callback(volatile void *tc,
		tc45_callback_t callback);

/**
 * \brief TC45r/ߊlA荞݌Ăі߂֐ݒ
 *
 * ̊֐͊荞݌Ăі߂֐ݒ肵ĕύX邱ƂĂяoɋ܂B
 * Ăі߂֐̐ݒȂłײޓ̊荞ݏ荞ݗv׸ނ
 * ܂B
 *
 * \param  tc       /(TC45)ڽւ̈ʒuwq
 * \param  callback Ăі߂֐ւ̎QƊ
 */
void tc45_set_cca_interrupt_callback(volatile void *tc,
		tc45_callback_t callback);

/**
 * \brief TC45r/ߊlB荞݌Ăі߂֐ݒ
 *
 * ̊֐͊荞݌Ăі߂֐ݒ肵ĕύX邱ƂĂяoɋ܂B
 * Ăі߂֐̐ݒȂłײޓ̊荞ݏ荞ݗv׸ނ
 * ܂B
 *
 * \param  tc       /(TC45)ڽւ̈ʒuwq
 * \param  callback Ăі߂֐ւ̎QƊ
 */
void tc45_set_ccb_interrupt_callback(volatile void *tc,
		tc45_callback_t callback);

/**
 * \brief TC45r/ߊlC荞݌Ăі߂֐ݒ
 *
 * ̊֐͊荞݌Ăі߂֐ݒ肵ĕύX邱ƂĂяoɋ܂B
 * Ăі߂֐̐ݒȂłײޓ̊荞ݏ荞ݗv׸ނ
 * ܂B
 *
 * \param  tc       /(TC45)ڽւ̈ʒuwq
 * \param  callback Ăі߂֐ւ̎QƊ
 */
void tc45_set_ccc_interrupt_callback(volatile void *tc,
		tc45_callback_t callback);

/**
 * \brief TC45r/ߊlD荞݌Ăі߂֐ݒ
 *
 * ̊֐͊荞݌Ăі߂֐ݒ肵ĕύX邱ƂĂяoɋ܂B
 * Ăі߂֐̐ݒȂłײޓ̊荞ݏ荞ݗv׸ނ
 * ܂B
 *
 * \param  tc       /(TC45)ڽւ̈ʒuwq
 * \param  callback Ăі߂֐ւ̎QƊ
 */
void tc45_set_ccd_interrupt_callback(volatile void *tc,
		tc45_callback_t callback);

/**
 * \brief TC45ꊄ荞ٌ`Ԑݒ
 *
 * \param  tc    TC45Pʕւ̈ʒuwq
 * \param  level ꊄ荞
 * \note INTCTRLAOVFINTLVL`Ԑݒ肵܂B
 */
static inline void tc45_set_overflow_interrupt_level(volatile void *tc,
		enum TC45_INT_LEVEL_t level)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->INTCTRLA = ((TC4_t *)tc)->INTCTRLA &
				~TC4_OVFINTLVL_gm;
		((TC4_t *)tc)->INTCTRLA
			= ((TC4_t *)tc)->INTCTRLA | (level << TC4_OVFINTLVL_gp);
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->INTCTRLA = ((TC5_t *)tc)->INTCTRLA &
				~TC5_OVFINTLVL_gm;
		((TC5_t *)tc)->INTCTRLA
			= ((TC5_t *)tc)->INTCTRLA | (level << TC5_OVFINTLVL_gp);
	}
}

/**
 * \brief TC45ُ튄荞ٌ`Ԑݒ
 *
 * \param  tc    TC45Pʕւ̈ʒuwq
 * \param  level ُ튄荞
 * \note INTCTRLAERRINTLVL`Ԑݒ肵܂B
 */
static inline void tc45_set_error_interrupt_level(volatile void *tc,
		enum TC45_INT_LEVEL_t level)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->INTCTRLA = ((TC4_t *)tc)->INTCTRLA &
				~TC4_ERRINTLVL_gm;
		((TC4_t *)tc)->INTCTRLA
			= ((TC4_t *)tc)->INTCTRLA | (level << TC4_ERRINTLVL_gp);
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->INTCTRLA = ((TC5_t *)tc)->INTCTRLA &
				~TC5_ERRINTLVL_gm;
		((TC5_t *)tc)->INTCTRLA
			= ((TC5_t *)tc)->INTCTRLA | (level << TC5_ERRINTLVL_gp);
	}
}

/**
 * \brief TC45r/ߊlA荞ٌ`Ԑݒ
 *
 * \param  tc    TC45Pʕւ̈ʒuwq
 * \param  level CCA荞
 * \note INTCTRLBCCAINTLVL`Ԑݒ肵܂B
 */
static inline void tc45_set_cca_interrupt_level(volatile void *tc,
		enum TC45_INT_LEVEL_t level)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->INTCTRLB = ((TC4_t *)tc)->INTCTRLB &
				~TC4_CCAINTLVL_gm;
		((TC4_t *)tc)->INTCTRLB
			= ((TC4_t *)tc)->INTCTRLB | (level << TC4_CCAINTLVL_gp);
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->INTCTRLB = ((TC5_t *)tc)->INTCTRLB &
				~TC5_CCAINTLVL_gm;
		((TC5_t *)tc)->INTCTRLB
			= ((TC5_t *)tc)->INTCTRLB | (level << TC5_CCAINTLVL_gp);
	}
}

/**
 * \brief TC45r/ߊlB荞ٌ`Ԑݒ
 *
 * \param  tc    TC45Pʕւ̈ʒuwq
 * \param  level CCB荞
 * \note INTCTRLBCCBINTLVL`Ԑݒ肵܂B
 */
static inline void tc45_set_ccb_interrupt_level(volatile void *tc,
		enum TC45_INT_LEVEL_t level)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->INTCTRLB = ((TC4_t *)tc)->INTCTRLB &
				~TC4_CCBINTLVL_gm;
		((TC4_t *)tc)->INTCTRLB
			= ((TC4_t *)tc)->INTCTRLB | (level << TC4_CCBINTLVL_gp);
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->INTCTRLB = ((TC5_t *)tc)->INTCTRLB &
				~TC5_CCBINTLVL_gm;
		((TC5_t *)tc)->INTCTRLB
			= ((TC5_t *)tc)->INTCTRLB | (level << TC5_CCBINTLVL_gp);
	}
}

/**
 * \brief TC45r/ߊlC荞ٌ`Ԑݒ
 *
 * \param  tc    TC45Pʕւ̈ʒuwq
 * \param  level CCC荞
 * \note INTCTRLBCCCINTLVL`Ԑݒ肵܂B
 */
static inline void tc45_set_ccc_interrupt_level(volatile void *tc,
		enum TC45_INT_LEVEL_t level)
{
	((TC4_t *)tc)->INTCTRLB = ((TC4_t *)tc)->INTCTRLB & ~TC4_CCCINTLVL_gm;
	((TC4_t *)tc)->INTCTRLB
		= ((TC4_t *)tc)->INTCTRLB | (level << TC4_CCCINTLVL_gp);
}

/**
 * \brief TC45r/ߊlD荞ٌ`Ԑݒ
 *
 * \param  tc    TC45Pʕւ̈ʒuwq
 * \param  level CCD荞
 * \note INTCTRLBCCDINTLVL`Ԑݒ肵܂B
 */
static inline void tc45_set_ccd_interrupt_level(volatile void *tc,
		enum TC45_INT_LEVEL_t level)
{
	((TC4_t *)tc)->INTCTRLB = ((TC4_t *)tc)->INTCTRLB & ~TC4_CCDINTLVL_gm;
	((TC4_t *)tc)->INTCTRLB
		= ((TC4_t *)tc)->INTCTRLB | (level << TC4_CCDINTLVL_gp);
}

/* @} */

/**
 * \brief Ouœ`Ԑݒ
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note CTRLASYNCHEN`Ԑݒ肵܂B
 */
static inline void tc45_write_synchen(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLA
			= (((TC4_t *)tc)->CTRLA | 0x40);
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLA
			= (((TC5_t *)tc)->CTRLA | 0x40);
	}
}

/**
 * \brief EVSTART(̎ۂŊJn)ޯĂݒ
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note CTRLAEVSTART`Ԑݒ肵܂B
 */
static inline void tc45_set_evstart(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLA = (((TC4_t *)tc)->CTRLA | TC4_EVSTART_bm);
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLA = (((TC5_t *)tc)->CTRLA | TC5_EVSTART_bm);
	}
}

/**
 * \brief UPSTOP(̍XVŒ~)ޯĂݒ
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note CTRLAUPSTOP`Ԑݒ
 */
static inline void tc45_set_up3(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLA = (((TC4_t *)tc)->CTRLA | TC4_UPSTOP_bm);
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLA = (((TC5_t *)tc)->CTRLA | TC5_UPSTOP_bm);
	}
}

/**
 * \brief STOP(TC~)ޯĂݒ
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note CTRLGSETSTOP`Ԑݒ
 */
static inline void tc45_set_stop(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLGSET = TC4_STOP_bm;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLGSET = TC5_STOP_bm;
	}
}

/**
 * \brief / ۯI`Ԑݒ
 *
 * \param  tc               TC45Pʕւ̈ʒuwq
 * \param  TC45_CLKSEL_enum ۯI
 * \note /Jnۯ`Ԑݒ肵܂B
 */
static inline void tc45_write_clock_source(volatile void *tc,
		TC45_CLKSEL_t TC45_CLKSEL_enum)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLA
			= (((TC4_t *)tc)->CTRLA & ~TC4_CLKSEL_gm) |
				TC45_CLKSEL_enum;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLA
			= (((TC5_t *)tc)->CTRLA & ~TC5_CLKSEL_gm) |
				TC45_CLKSEL_enum;
	}
}

/**
 * \brief / ۯǂݍ
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \return TC45_CLKSEL_enum ۯI
 */
static inline TC45_CLKSEL_t tc45_read_clock_source(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		return (TC45_CLKSEL_t)(((TC4_t *)tc)->CTRLA & TC4_CLKSEL_gm);
	} else if (tc45_is_TC5(void *tc)) {
		return (TC45_CLKSEL_t)(((TC5_t *)tc)->CTRLA & TC5_CLKSEL_gm);
	}

	Assert(false);
	return TC45_CLKSEL_OFF_gc;
}

/**
 * \brief w肵TC45ƕ\ɑ΂ۯI
 *
 * ̊֐͎w肵TC45w肵̂ƍŒłʍ\^悤
 * ɁAOuꂽCLkperƂĸۯI`Ԑݒ肵܂BTC45̕\͂
 * ۯgƓƂӖ܂B
 *
 * \note قTCۯ쓮邱Ƃ\łB͂̎ɂĈ
 *       ܂B
 *
 * \param  tc         ۯI𓾂TC45̎ʎq
 * \param  resolution TC45ɑ΂Hzł̖]ޕ@\
 */
static inline void tc45_set_resolution(volatile void *tc, uint32_t resolution)
{
	uint32_t tc45_clk_rate = sysclk_get_per_hz();

	if (resolution <= (tc45_clk_rate / 1024)) {
		tc45_write_clock_source(tc, TC45_CLKSEL_DIV1024_gc);
	} else if (resolution <= (tc45_clk_rate / 256)) {
		tc45_write_clock_source(tc, TC45_CLKSEL_DIV256_gc);
	} else if (resolution <= (tc45_clk_rate / 64)) {
		tc45_write_clock_source(tc, TC45_CLKSEL_DIV64_gc);
	} else if (resolution <= (tc45_clk_rate / 8)) {
		tc45_write_clock_source(tc, TC45_CLKSEL_DIV8_gc);
	} else if (resolution <= (tc45_clk_rate / 4)) {
		tc45_write_clock_source(tc, TC45_CLKSEL_DIV4_gc);
	} else if (resolution <= (tc45_clk_rate / 2)) {
		tc45_write_clock_source(tc, TC45_CLKSEL_DIV2_gc);
	} else {
		tc45_write_clock_source(tc, TC45_CLKSEL_DIV1_gc);
	}
}

/**
 * \brief w肵TC45ɑ΂ۂ̕\擾
 *
 * ̊֐TC45̎w肵ۯIA\Ԃ܂BTC45̕\͂
 * ̸ۯgƓƂӖ܂B
 *
 * \note ̊֐͎ ۯI܂B
 *
 * \param  tc \𓾂TC45Pʕւ̈ʒuwq
 *
 * \return TC̕@\
 */
static inline uint32_t tc45_get_resolution(volatile void *tc)
{
	uint32_t tc45_clk_rate = sysclk_get_per_hz();
	switch (tc45_read_clock_source(tc)) {
	case TC45_CLKSEL_OFF_gc:
		tc45_clk_rate = 0;
		break;

	case TC45_CLKSEL_DIV1024_gc:
		tc45_clk_rate /= 1024;
		break;

	case TC45_CLKSEL_DIV256_gc:
		tc45_clk_rate /= 256;
		break;

	case TC45_CLKSEL_DIV64_gc:
		tc45_clk_rate /= 64;
		break;

	case TC45_CLKSEL_DIV8_gc:
		tc45_clk_rate /= 8;
		break;

	case TC45_CLKSEL_DIV4_gc:
		tc45_clk_rate /= 4;
		break;

	case TC45_CLKSEL_DIV2_gc:
		tc45_clk_rate /= 2;
		break;

	case TC45_CLKSEL_DIV1_gc:
		break;

	default:
		tc45_clk_rate = 0;
		break;
	}
	return (tc45_clk_rate);
}

/**
 * \brief /`Ԑݒ
 *
 * \param  tc  TC45Pʕւ̈ʒuwq
 * \param  dir /
 */
static inline void tc45_set_direction(volatile void *tc, enum tc45_dir_t dir)
{
	if (dir == TC45_UP) {
		if (tc45_is_TC4(void *tc)) {
			((TC4_t *)tc)->CTRLGCLR = TC4_DIR_bm;
		} else if (tc45_is_TC5(void *tc)) {
			((TC5_t *)tc)->CTRLGCLR = TC4_DIR_bm;
		}
	} else {
		if (tc45_is_TC4(void *tc)) {
			((TC4_t *)tc)->CTRLGSET = TC4_DIR_bm;
		} else if (tc45_is_TC5(void *tc)) {
			((TC5_t *)tc)->CTRLGSET = TC5_DIR_bm;
		}
	}
}

/**
 * \brief /̌vl
 *
 * \param  tc        TC45Pʕւ̈ʒuwq
 * \param  cnt_value vl
 */
static inline void tc45_write_count(volatile void *tc, uint16_t cnt_value)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CNT = cnt_value;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CNT = cnt_value;
	}
}

/**
 * \brief /̌vlǂݍ
 *
 * \param  tc        TC45Pʕւ̈ʒuwq
 * \note vl(CNT)o
 *
 * \return TČv(CNT)l
 */
static inline uint16_t tc45_read_count(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		return (((TC4_t *)tc)->CNT);
	} else if (tc45_is_TC5(void *tc)) {
		return (((TC5_t *)tc)->CNT);
	}

	Assert(false);
	return 0;
}

/**
 * \brief /̒l
 *
 * \param  tc        TC45Pʕւ̈ʒuwq
 * \param  per_value (PER)l
 */
static inline void tc45_write_period(volatile void *tc, uint16_t per_value)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->PER = per_value;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->PER = per_value;
	}
}

/**
 * \brief /̒lǂݍ
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \return (PER)l
 */
static inline uint16_t tc45_read_period(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		return (((TC4_t *)tc)->PER);
	} else if (tc45_is_TC5(void *tc)) {
		return (((TC5_t *)tc)->PER);
	}

	Assert(false);
	return 0;
}

/**
 * \brief /̒ɏՕl
 *
 * \param  tc      TC45Pʕւ̈ʒuwq
 * \param  per_buf ɏՕ(PERBUF)l
 */
static inline void tc45_write_period_buffer(volatile void *tc, uint16_t per_buf)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->PERBUF = per_buf;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->PERBUF = per_buf;
	}
}

/**
 * \brief /̒ɏՕlǂݍ
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \return ɏՕ(PERBUF)l
 */
static inline uint16_t tc45_read_period_buffer(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		return (((TC4_t *)tc)->PERBUF);
	} else if (tc45_is_TC5(void *tc)) {
		return (((TC5_t *)tc)->PERBUF);
	}

	Assert(false);
	return 0;
}

/**
 * \brief ɏՕL
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \return ɏՕLۂ:PERBV
 */
static inline bool tc45_period_buffer_is_valid(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		return (((TC4_t *)tc)->CTRLHCLR & TC4_PERBV_bm);
	} else if (tc45_is_TC5(void *tc)) {
		return (((TC5_t *)tc)->CTRLHCLR & TC5_PERBV_bm);
	}

	Assert(false);
	return false;
}

/**
 * \brief (32ޯ /Ŏgp)x
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 * \note x싖
 */
static inline void tc45_enable_delay(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLD = (((TC4_t *)tc)->CTRLD &
				~TC4_EVDLY_bm) | (1 << TC4_EVDLY_bp);
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLD = (((TC5_t *)tc)->CTRLD &
				~TC5_EVDLY_bm) | (1 << TC5_EVDLY_bp);
	}
}

/**
 * \brief x֎~
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 * \note x֎~
 */
static inline void tc45_disable_delay(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLD = ((TC4_t *)tc)->CTRLD & ~TC4_EVDLY_bm;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLD = ((TC5_t *)tc)->CTRLD & ~TC5_EVDLY_bm;
	}
}

/**
 * \brief ׸ނݒ肳Ă邩
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \return ꂪNۂ: OVFIF
 */
static inline bool tc45_is_overflow(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		return (((TC4_t *)tc)->INTFLAGS & TC4_OVFIF_bm);
	} else if (tc45_is_TC5(void *tc)) {
		return (((TC5_t *)tc)->INTFLAGS & TC5_OVFIF_bm);
	}

	Assert(false);
	return false;
}

/**
 * \brief ׸މ
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note OVFIF܂B
 */
static inline void tc45_clear_overflow(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->INTFLAGS |= TC4_OVFIF_bm;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->INTFLAGS |= TC5_OVFIF_bm;
	}
}

/**
 * \brief ُ׸ނݒ肳Ă邩
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \return ُ킪Nۂ: ERRIF
 */
static inline bool tc45_read_error(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		return (((TC4_t *)tc)->INTFLAGS & TC4_ERRIF_bm);
	} else if (tc45_is_TC5(void *tc)) {
		return (((TC5_t *)tc)->INTFLAGS & TC5_ERRIF_bm);
	}

	Assert(false);
	return false;
}

/**
 * \brief ُ׸ނ
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note ERRIF܂B
 */
static inline void tc45_clear_error(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->INTFLAGS |= TC4_ERRIF_bm;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->INTFLAGS |= TC5_ERRIF_bm;
	}
}

/**
 * \brief /Ďn
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note CTRLGSETCMD[3:2]10ɐݒ肳܂B
 */
static inline void tc45_restart(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLGSET = TC45_CMD_RESTART_gc;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLGSET = TC45_CMD_RESTART_gc;
	}
}

/**
 * \brief /ؾ
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note CTRLGSETCMD[3:2]11ɐݒ肳܂B
 */
static inline void tc45_reset(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLGSET = TC45_CMD_RESET_gc;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLGSET = TC45_CMD_RESET_gc;
	}
}

/**
 * \brief /XV
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note CTRLGSETCMD[3:2]01ɐݒ肳܂B
 */
static inline void tc45_update(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLGSET = TC45_CMD_UPDATE_gc;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLGSET = TC45_CMD_UPDATE_gc;
	}
}

/**
 * \brief /޲ēɌ`Ԑݒ
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note CTRLBBYTEM`Ԑݒ肵܂B
 */
static inline void tc45_set_8bits_mode(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
#ifdef TC4_BYTEM0_bm
		((TC4_t *)tc)->CTRLB |= TC4_BYTEM0_bm;
#else
		((TC4_t *)tc)->CTRLB |= TC4_BYTEM_bm;
#endif
	} else if (tc45_is_TC5(void *tc)) {
#ifdef TC5_BYTEM0_bm
		((TC5_t *)tc)->CTRLB |= TC5_BYTEM0_bm;
#else
		((TC5_t *)tc)->CTRLB |= TC5_BYTEM_bm;
#endif
	}
}

/**
 * \brief ɏՂꂽڼ޽̍XV{
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note CTRLGSETLUPD`Ԑݒ肵܂B
 *
 *  */
static inline void tc45_lock_update_buffers(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLGSET = TC4_LUPD_bm;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLGSET = TC5_LUPD_bm;
	}
}

/**
 * \brief ɏՂꂽڼ޽̍XV
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note CTRLGCLRLUPD`Ԑݒ肵܂B
 */
static inline void tc45_unlock_update_buffers(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLGCLR = TC4_LUPD_bm;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLGCLR = TC5_LUPD_bm;
	}
}

/**
 * \brief o̗͂D挠ύX
 *
 * \param  tc TC45Pʕւ̈ʒuwq
 *
 * \note CTRLCPOLޯĂ`Ԑݒ肵܂B
 */
static inline void tc45_pol(volatile void *tc)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLC = ((TC4_t *)tc)->CTRLC | TC4_POLD_bm |
				TC4_POLC_bm | TC4_POLB_bm | TC4_POLA_bm;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLC |= ((TC5_t *)tc)->CTRLC | TC5_POLB_bm |
				TC5_POLA_bm;
	}
}

/**
 * \brief r/ߊlق
 *
 * \param  tc         TC45Pʕւ̈ʒuwq
 * \param  enambemask CC
 */
static inline void tc45_enable_cc_channels(volatile void *tc,
		enum tc45_cc_channel_mask_enable_t enablemask)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLE |= enablemask;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLE
			|= enablemask &
				((uint8_t)TC45_CCAMODE_COMP_gc |
				(uint8_t)TC45_CCBMODE_COMP_gc |
				(uint8_t)TC45_CCAMODE_CAPT_gc |
				(uint8_t)TC45_CCBMODE_CAPT_gc);
	}
}

/**
 * \brief r/ߊlق֎~
 *
 * \param  tc          TC45Pʕւ̈ʒuwq
 * \param  disablemask CC
 */
static inline void tc45_disable_cc_channels(volatile void *tc,
		enum tc45_cc_channel_mask_enable_t disablemask)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLE &= ~disablemask;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLE
			&= ~(disablemask &
				((uint8_t)TC45_CCAMODE_COMP_gc |
				(uint8_t)TC45_CCBMODE_COMP_gc));
	}
}

/**
 * \brief ߊl͓싖
 *
 * \param  tc          TC45Pʕւ̈ʒuwq
 * \param  eventsource ߊlp
 * \param  eventaction ۊߊl^
 */
static inline void tc45_set_input_capture(volatile void *tc,
		TC45_EVSEL_t eventsource, TC45_EVACT_t eventaction)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLD &= ~(TC4_EVSEL_gm | TC4_EVACT_gm);
		((TC4_t *)tc)->CTRLD
			|= ((uint8_t)eventsource | (uint8_t)eventaction);
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLD &= ~(TC5_EVSEL_gm | TC5_EVACT_gm);
		((TC5_t *)tc)->CTRLD
			|= ((uint8_t)eventsource | (uint8_t)eventaction);
	}
}

/**
 * \brief ߊllǂݍ
 *
 * \param  tc            TC45Pʕւ̈ʒuwq
 * \param  channel_index x
 *
 * \return CC̒l
 */
static inline uint16_t tc45_read_cc(volatile void *tc,
		enum tc45_cc_channel_t channel_index)
{
	if (tc45_is_TC4(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			return (((TC4_t *)tc)->CCA);

		case TC45_CCB:
			return (((TC4_t *)tc)->CCB);

		case TC45_CCC:
			return (((TC4_t *)tc)->CCC);

		case TC45_CCD:
			return (((TC4_t *)tc)->CCD);
		}
	} else if (tc45_is_TC5(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			return (((TC5_t *)tc)->CCA);

		case TC45_CCB:
			return (((TC5_t *)tc)->CCB);

		default:
			return (0);
		}
	}

	return (0);
}

/**
 * \brief CCl
 *
 * \param  tc            TC45Pʕւ̈ʒuwq
 * \param  channel_index CC
 * \param  value         vl
 */
static inline void tc45_write_cc(volatile void *tc,
		enum tc45_cc_channel_t channel_index, uint16_t value)
{
	if (tc45_is_TC4(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			((TC4_t *)tc)->CCA = value;
			break;

		case TC45_CCB:
			((TC4_t *)tc)->CCB = value;
			break;

		case TC45_CCC:
			((TC4_t *)tc)->CCC = value;
			break;

		case TC45_CCD:
			((TC4_t *)tc)->CCD = value;
			break;
		}
	} else if (tc45_is_TC5(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			((TC5_t *)tc)->CCA = value;
			break;

		case TC45_CCB:
			((TC5_t *)tc)->CCB = value;
			break;

		default:
			return;
		}
	}
}

/**
 * \brief r/ߊlɏՒl
 *
 * \param  tc            TC45Pʕւ̈ʒuwq
 * \param  channel_index CC
 * \param  buffer_value  vɏՕl
 */
static inline void tc45_write_cc_buffer(volatile void *tc,
		enum tc45_cc_channel_t channel_index, uint16_t buffer_value)
{
	if (tc45_is_TC4(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			((TC4_t *)tc)->CCABUF = buffer_value;
			break;

		case TC45_CCB:
			((TC4_t *)tc)->CCBBUF = buffer_value;
			break;

		case TC45_CCC:
			((TC4_t *)tc)->CCCBUF = buffer_value;
			break;

		case TC45_CCD:
			((TC4_t *)tc)->CCDBUF = buffer_value;
			break;
		}
	} else if (tc45_is_TC5(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			((TC5_t *)tc)->CCABUF = buffer_value;
			break;

		case TC45_CCB:
			((TC5_t *)tc)->CCBBUF = buffer_value;
			break;

		default:
			return;
		}
	}
}

/**
 * \brief r/ߊlɏՕlǂݍ
 *
 * \param  tc            TC45Pʕւ̈ʒuwq
 * \param  channel_index CC
 *
 * \return CCxɏՕl
 */
static inline uint16_t tc45_read_cc_buffer(volatile void *tc,
		enum tc45_cc_channel_t channel_index)
{
	if (tc45_is_TC4(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			return (((TC4_t *)tc)->CCABUF);

		case TC45_CCB:
			return (((TC4_t *)tc)->CCBBUF);

		case TC45_CCC:
			return (((TC4_t *)tc)->CCCBUF);

		case TC45_CCD:
			return (((TC4_t *)tc)->CCDBUF);
		}
	} else if (tc45_is_TC5(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			return (((TC5_t *)tc)->CCABUF);

		case TC45_CCB:
			return (((TC5_t *)tc)->CCBBUF);

		default:
			return (0);
		}
	}

	return (0);
}

/**
 * \brief r/ߊlɏՕL
 *
 * \param  tc            TC45Pʕւ̈ʒuwq
 * \param  channel_index CC
 *
 * \return CCxɏՕLۂ
 */
static inline bool tc45_cc_buffer_is_valid(volatile void *tc,
		enum tc45_cc_channel_t channel_index)
{
	if (tc45_is_TC4(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			return ((TC4_t *)tc)->CTRLGCLR & TC4_CCABV_bm;

		case TC45_CCB:
			return ((TC4_t *)tc)->CTRLGCLR & TC4_CCBBV_bm;

		case TC45_CCC:
			return ((TC4_t *)tc)->CTRLGCLR & TC4_CCCBV_bm;

		case TC45_CCD:
			return ((TC4_t *)tc)->CTRLGCLR & TC4_CCDBV_bm;
		}
	} else if (tc45_is_TC5(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			return (((TC5_t *)tc)->CTRLGCLR &
			       TC5_CCABV_bm);

		case TC45_CCB:
			return (((TC5_t *)tc)->CTRLGCLR &
			       TC5_CCBBV_bm);

		default:
			return (0);
		}
	}

	return (0);
}

/**
 * \brief r/ߊl荞݂N
 *
 * \param  tc            TC45Pʕւ̈ʒuwq
 * \param  channel_index CC
 *
 * \return CCx荞݂ۂ
 */
static inline bool tc45_is_cc_interrupt(volatile void *tc,
		enum tc45_cc_channel_t channel_index)
{
	if (tc45_is_TC4(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			return (((TC4_t *)tc)->INTFLAGS & TC4_CCAIF_bm);

		case TC45_CCB:
			return (((TC4_t *)tc)->INTFLAGS & TC4_CCBIF_bm);

		case TC45_CCC:
			return (((TC4_t *)tc)->INTFLAGS & TC4_CCCIF_bm);

		case TC45_CCD:
			return (((TC4_t *)tc)->INTFLAGS & TC4_CCDIF_bm);
		}
	} else if (tc45_is_TC5(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			return (((TC5_t *)tc)->INTFLAGS &
			       TC5_CCAIF_bm);

		case TC45_CCB:
			return (((TC5_t *)tc)->INTFLAGS &
			       TC5_CCBIF_bm);

		default:
			return (0);
		}
	}

	return (0);
}

/**
 * \brief r/r荞݉
 *
 * \param  tc            TC45Pʕւ̈ʒuwq
 * \param  channel_index CC
 */
static inline void tc45_clear_cc_interrupt(volatile void *tc,
		enum tc45_cc_channel_t channel_index)
{
	if (tc45_is_TC4(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			((TC4_t *)tc)->INTFLAGS = TC4_CCAIF_bm;
			break;

		case TC45_CCB:
			((TC4_t *)tc)->INTFLAGS = TC4_CCBIF_bm;
			break;

		case TC45_CCC:
			((TC4_t *)tc)->INTFLAGS = TC4_CCCIF_bm;
			break;

		case TC45_CCD:
			((TC4_t *)tc)->INTFLAGS = TC4_CCDIF_bm;
			break;
		}
	} else if (tc45_is_TC5(void *tc)) {
		switch (channel_index) {
		case TC45_CCA:
			((TC5_t *)tc)->INTFLAGS = TC5_CCAIF_bm;
			break;

		case TC45_CCB:
			((TC5_t *)tc)->INTFLAGS = TC5_CCBIF_bm;
			break;

		default:
			return;
		}
	}
}

/**
 * \brief TC45w肵g`퓮Ɍ`Ԑݒ
 *
 * \param  tc  TC45Pʕւ̈ʒuwq
 * \param  wgm g`퓮
 */
static inline void tc45_set_wgm(volatile void *tc, enum tc45_wg_mode_t wgm)
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLB
			= (((TC4_t *)tc)->CTRLB & ~TC4_WGMODE_gm) | wgm;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLB
			= (((TC5_t *)tc)->CTRLB & ~TC5_WGMODE_gm) | wgm;
	}
}

/********************************************************
*		QPʕ										*
********************************************************/

/**
 * \brief QPʕ : QRAMP2`Ԑݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_ramp2_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLA |= FAULT_RAMP_RAMP2_gc;
}

/**
 * \brief QPʕ : QAQUAL`Ԑݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_qualA_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLC |= FAULT_QUALA_bm;
}

/**
 * \brief QPʕ : QBQUAL`Ԑݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_qualB_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLE |= FAULT_QUALB_bm;
}

/**
 * \brief QPʕ : QABLANK`Ԑݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_blankA_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLC |= FAULT_BLANKA_bm;
}

/**
 * \brief QPʕ : QBBLANK`Ԑݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_blankB_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLC |= FAULT_BLANKB_bm;
}

/**
 * \brief g`g : 󔒎Ԃ`Ԑݒ
 *
 * \param  WEX   g`gPʕւ̈ʒuwq
 * \param  value 󔒒l
 */
static inline void tc45_fault_set_blank_time(WEX_t *WEX, int16_t value)
{
	((WEX_t *)WEX)->DTLS = value;	/* 󔒎 */
}

/**
 * \brief QPʕ : QA͂`Ԑݒ
 *
 * \param  FAULT  QPʕւ̈ʒuwq
 * \param  source Q(N,N+1,`)
 */

static inline void tc45_fault_configure_sourceA_input(FAULT_t *FAULT,
		enum fault_sourceA_mode_t source)
{
	((FAULT_t *)FAULT)->CTRLB
		= (((FAULT_t *)FAULT)->CTRLB & ~FAULT_SRCA_gm) | source;
}

/**
 * \brief QPʕ : QB͂`Ԑݒ
 *
 * \param  FAULT  QPʕւ̈ʒuwq
 * \param  source Q(N,N+1,`)
 */

static inline void tc45_fault_configure_sourceB_input(FAULT_t *FAULT,
		enum fault_sourceB_mode_t source)
{
	((FAULT_t *)FAULT)->CTRLD
		= (((FAULT_t *)FAULT)->CTRLD & ~FAULT_SRCB_gm) | source;
}

/**
 * \brief QPʕ : QE͂`Ԑݒ
 *
 * \param  FAULT  QPʕւ̈ʒuwq
 * \param  source Q(N,N+1,`)
 */

static inline void tc45_fault_configure_sourceE_input(FAULT_t *FAULT,
		enum fault_sourceE_mode_t source)
{
	((FAULT_t *)FAULT)->CTRLA
		= (((FAULT_t *)FAULT)->CTRLA & ~FAULT_SRCE_gm) | source;
}

/**
 * \brief QPʕ : QEłhg
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_faultE_filter(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLA |= FAULT_FILTERE_bm;
}

/**
 * \brief QPʕ : QAłhg
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_faultA_filter(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLC |= FAULT_FILTERA_bm;
}

/**
 * \brief QPʕ : QBłhg
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_faultB_filter(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLE |= FAULT_FILTERB_bm;
}

/**
 * \brief QPʕ : QA̍Ďnݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_restartA_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLB |= FAULT_RESTARTA_bm;
}

/**
 * \brief QPʕ : QB̍Ďnݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_restartB_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLD |= FAULT_RESTARTB_bm;
}

/**
 * \brief QPʕ : QA̕ێݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_keepA_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLB |= FAULT_KEEPA_bm;
}

/**
 * \brief QPʕ : QB̕ێݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_keepB_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLD |= FAULT_KEEPB_bm;
}

/**
 * \brief QPʕ : QA̿ĳݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_softA_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLB |= FAULT_SOFTA_bm;
}

/**
 * \brief QPʕ : QB̿ĳݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_softB_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLD |= FAULT_SOFTB_bm;
}

/**
 * \brief QPʕ : QA̕ߊlݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_captA_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLC |= FAULT_CAPTA_bm;
}

/**
 * \brief QPʕ : QB̕ߊlݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_captB_mode(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLE |= FAULT_CAPTB_bm;
}

/**
 * \brief QPʕ : QA̒~`Ԑݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 * \param  fault ~
 */

static inline void tc45_fault_set_haltA_mode(FAULT_t *FAULT,
		enum fault_haltA_mode_t fault)
{
	((FAULT_t *)FAULT)->CTRLB
		= (((FAULT_t *)FAULT)->CTRLB & ~FAULT_HALTA_gm) | fault;
}

/**
 * \brief QPʕ : QB̒~`Ԑݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 * \param  fault ~
 */

static inline void tc45_fault_set_haltB_mode(FAULT_t *FAULT,
		enum fault_haltB_mode_t fault)
{
	((FAULT_t *)FAULT)->CTRLD
		= (((FAULT_t *)FAULT)->CTRLD & ~FAULT_HALTB_gm) | fault;
}

/*! \brief /ً`Ԑݒ
 *
 *  \param  tc          /Pʕ
 *  \param  eventSource ي
 */
static inline void tc45_config_fault_input_evsel(volatile void *tc,
		TC45_EVSEL_t eventSource )
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLD
			= (((TC4_t *)tc)->CTRLD & ~(TC4_EVSEL_gm)) |
				eventSource;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLD
			= (((TC5_t *)tc)->CTRLD & ~(TC5_EVSEL_gm)) |
				eventSource;
	}
}

/*! \brief /ۓ`Ԑݒ
 *
 *  \param  tc          /Pʕ
 *  \param  eventAction ߊlAQDECA`
 */
static inline void tc45_config_fault_input_evact(volatile void *tc,
		TC45_EVSEL_t eventAction )
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLD
			= (((TC4_t *)tc)->CTRLD & ~(TC4_EVACT_gm)) |
				eventAction;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLD
			= (((TC5_t *)tc)->CTRLD & ~(TC5_EVACT_gm)) |
				eventAction;
	}
}

/*! \brief /FMODE1`Ԑݒ
 *
 *  \param  tc          /Pʕ
 *  \param  eventSource ي
 */
static inline void tc45_config_fault_input_fmode1(volatile void *tc,
		TC45_EVSEL_t eventSource )
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLD
			= (((TC4_t *)tc)->CTRLD &
				~(TC4_EVSEL_gm | TC4_EVACT_gm)) |
				eventSource |
				TC45_EVACT_FMODE1_gc;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLD
			= (((TC5_t *)tc)->CTRLD &
				~(TC5_EVSEL_gm | TC5_EVACT_gm)) |
				eventSource |
				TC45_EVACT_FMODE1_gc;
	}
}

/*! \brief /FMODE2`Ԑݒ
 *
 *  \param  tc          /Pʕ
 *  \param  eventSource ي
 */
static inline void tc45_config_fault_input_fmode2(volatile void *tc,
		TC45_EVSEL_t eventSource )
{
	if (tc45_is_TC4(void *tc)) {
		((TC4_t *)tc)->CTRLD
			= (((TC4_t *)tc)->CTRLD &
				~(TC4_EVSEL_gm | TC4_EVACT_gm)) |
				eventSource | TC45_EVACT_FMODE2_gc;
	} else if (tc45_is_TC5(void *tc)) {
		((TC5_t *)tc)->CTRLD
			= (((TC5_t *)tc)->CTRLD &
				~(TC5_EVSEL_gm | TC5_EVACT_gm)) |
				eventSource | TC45_EVACT_FMODE2_gc;
	}
}

/**
 * \brief QPʕ : QA݂邩ԂB
 *
 * \param  FAULT QPʕւ̈ʒuwq
 *
 * \return QA݂邩ۂ
 */

static inline bool tc45_fault_faultAin_is_detected(FAULT_t *FAULT)
{
	return ((FAULT_t *)FAULT)->STATUS & FAULT_FAULTAIN_bm;
}

/**
 * \brief QPʕ : QB݂邩ԂB
 *
 * \param  FAULT QPʕւ̈ʒuwq
 *
 * \return QB݂邩ۂ
 */

static inline bool tc45_fault_faultBin_is_detected(FAULT_t *FAULT)
{
	return ((FAULT_t *)FAULT)->STATUS & FAULT_FAULTBIN_bm;
}

/**
 * \brief QPʕ : QE݂邩ԂB
 *
 * \param  FAULT QPʕւ̈ʒuwq
 *
 * \return QE݂邩ۂ
 */

static inline bool tc45_fault_faultEin_is_detected(FAULT_t *FAULT)
{
	return ((FAULT_t *)FAULT)->STATUS & FAULT_FAULTEIN_bm;
}

/**
 * \brief QPʕ : QASTATEAŌo邩ԂB
 *
 * \param  FAULT QPʕւ̈ʒuwq
 *
 * \return QȀ
 */

static inline bool tc45_fault_stateA_is_detected(FAULT_t *FAULT)
{
	return ((FAULT_t *)FAULT)->STATUS & FAULT_STATEA_bm;
}

/**
 * \brief QPʕ : QBSTATEBŌo邩ԂB
 *
 * \param  FAULT QPʕւ̈ʒuwq
 *
 * \return QB̏
 */

static inline bool tc45_fault_stateB_is_detected(FAULT_t *FAULT)
{
	return ((FAULT_t *)FAULT)->STATUS & FAULT_STATEB_bm;
}

/**
 * \brief QPʕ : QESTATEEŌo邩ԂB
 *
 * \param  FAULT QPʕւ̈ʒuwq
 *
 * \return QȄ
 */

static inline bool tc45_fault_stateE_is_detected(FAULT_t *FAULT)
{
	return ((FAULT_t *)FAULT)->STATUS & FAULT_STATEE_bm;
}

/**
 * \brief QPʕ : HALTAQԂ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_clear_haltA(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGCLR = FAULT_HALTACLR_bm;
}

/**
 * \brief QPʕ : HALTBQԂ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */
static inline void tc45_fault_clear_haltB(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGCLR = FAULT_HALTBCLR_bm;
}

/**
 * \brief QPʕ : HALTEQԂ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */
static inline void tc45_fault_clear_stateE(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGCLR = FAULT_STATEECLR_bm;
}

/**
 * \brief QPʕ : FAULTAQo
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_clear_faultA(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGCLR |= FAULT_FAULTA_bm;
}

/**
 * \brief QPʕ : FAULTBQo
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_clear_faultB(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGCLR |= FAULT_FAULTB_bm;
}

/**
 * \brief QPʕ : FAULTEQo
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_clear_faultE(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGCLR |= FAULT_FAULTE_bm;
}

/**
 * \brief QPʕ : ĳQAݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_softwareA(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGSET |= FAULT_FAULTASW_bm;
}

/**
 * \brief QPʕ : ĳQBݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_softwareB(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGSET |= FAULT_FAULTBSW_bm;
}

/**
 * \brief QPʕ : ĳQEݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_softwareE(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGSET |= FAULT_FAULTESW_bm;
}

/**
 * \brief QPʕ : QPʕ߰Đݒ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */
static inline void tc45_fault_set_portcontrol(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLA |= FAULT_PORTCTRL_bm;
}

/**
 * \brief QPʕ : Q߰Đؾ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_reset_portcontrol(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLA &= ~FAULT_PORTCTRL_bm;
}

/**
 * \brief QPʕ : RAMP2ŎB(IDXݒ)
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_set_idx(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGSET
		= (((FAULT_t *)FAULT)->CTRLGSET &
			~FAULT_IDXCMD_gm) | FAULT_IDXCMD_SET_gc;
}

/**
 * \brief QPʕ : RAMP2ŎA(IDX)
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_clear_idx(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGSET
		= (((FAULT_t *)FAULT)->CTRLGSET &
			~FAULT_IDXCMD_gm) | FAULT_IDXCMD_CLEAR_gc;
}

/**
 * \brief QPʕ : RAMP2ŎN(IDXێ)ێ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_hold_idx(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGSET
		= (((FAULT_t *)FAULT)->CTRLGSET &
			~FAULT_IDXCMD_gm) | FAULT_IDXCMD_HOLD_gc;
}

/**
 * \brief QPʕ : RAMP2ŊIDX
 *
 * \param  FAULT QPʕւ̈ʒuwq
 */

static inline void tc45_fault_default_idx(FAULT_t *FAULT)
{
	((FAULT_t *)FAULT)->CTRLGSET
		= (((FAULT_t *)FAULT)->CTRLGSET & ~FAULT_IDXCMD_gm);
}

/**
 * \brief QPʕ : RAMP2IDXǂݍ
 *
 * \param  FAULT QPʕւ̈ʒuwq
 *
 * \return IDX`Ԑݒ
 */

static inline bool tc45_fault_read_idx(FAULT_t *FAULT)
{
	return ((FAULT_t *)FAULT)->STATUS & FAULT_IDX_bm;
}

/********************************************************
*		g`g(WeX)								*
********************************************************/

/**
 * \brief g`g : w肵o͔z񓮍Wex`Ԑݒ
 *
 * \param  WEX  g`Pʕւ̈ʒuwq
 * \param  otmx o͔z񓮍
 *
 */
static inline void tc45_wex_set_otmx(WEX_t *WEX, enum wex_otmx_mode_t otmx)
{
	((WEX_t *)WEX)->CTRL = (((WEX_t *)WEX)->CTRL & ~WEX_OTMX_gm) | otmx;
}

/**
 * \brief g`g : o͔z񓮍ǂݍ
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline uint16_t tc45_wex_read_otmx(WEX_t *WEX)
{
	return (((WEX_t *)WEX)->CTRL & WEX_OTMX_gm);
}

/**
 * \brief g`g : CCAŒَԑ}
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 */
static inline void tc45_wex_enable_cca_deadtime(WEX_t *WEX)
{
	((WEX_t *)WEX)->CTRL |= WEX_DTI0EN_bm;
}

/**
 * \brief g`g : CCAŒَԑ}֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 */
static inline void tc45_wex_disable_cca_deadtime(WEX_t *WEX)
{
	((WEX_t *)WEX)->CTRL &= ~WEX_DTI0EN_bm;
}

/**
 * \brief g`g : CCBŒَԑ}
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 */
static inline void tc45_wex_enable_ccb_deadtime(WEX_t *WEX)
{
	((WEX_t *)WEX)->CTRL |= WEX_DTI1EN_bm;
}

/**
 * \brief g`g : CCBŒَԑ}֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 */
static inline void tc45_wex_disable_ccb_deadtime(WEX_t *WEX)
{
	((WEX_t *)WEX)->CTRL &= ~WEX_DTI1EN_bm;
}

/**
 * \brief g`g : CCCŒَԑ}
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 */
static inline void tc45_wex_enable_ccc_deadtime(WEX_t *WEX)
{
	((WEX_t *)WEX)->CTRL |= WEX_DTI2EN_bm;
}

/**
 * \brief g`g : CCCŒَԑ}֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 */
static inline void tc45_wex_disable_ccc_deadtime(WEX_t *WEX)
{
	((WEX_t *)WEX)->CTRL &= ~WEX_DTI2EN_bm;
}

/**
 * \brief g`g : CCDŒَԑ}
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 */
static inline void tc45_wex_enable_ccd_deadtime(WEX_t *WEX)
{
	((WEX_t *)WEX)->CTRL |= WEX_DTI3EN_bm;
}

/**
 * \brief g`g : CCDŒَԑ}֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 */
static inline void tc45_wex_disable_ccd_deadtime(WEX_t *WEX)
{
	((WEX_t *)WEX)->CTRL &= ~WEX_DTI3EN_bm;
}

/**
 * \brief g`g : HighَԂ`Ԑݒ
 *
 * \param  WEX   g`Pʕւ̈ʒuwq
 * \param  value َԒl
 */
static inline void tc45_wex_set_dti_high(WEX_t *WEX, int16_t value)
{
	((WEX_t *)WEX)->DTHS = value;
}

/**
 * \brief g`g : LowَԂ`Ԑݒ
 *
 * \param  WEX   g`Pʕւ̈ʒuwq
 * \param  value َԒl
 */
static inline void tc45_wex_set_dti_low(WEX_t *WEX, int16_t value)
{
	((WEX_t *)WEX)->DTLS = value;
}

/**
 * \brief g`g : Ώَ̒Ԃ`Ԑݒ
 *
 * \param  WEX   g`Pʕւ̈ʒuwq
 * \param  value َԒl
 */
static inline void tc45_wex_set_dti_both(WEX_t *WEX, int16_t value)
{
	((WEX_t *)WEX)->DTBOTH = value;
}

/**
 * \brief g`g : OTMX01ł̓ւ
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_enable_swap0(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAP |= WEX_SWAP0_bm;
}

/**
 * \brief g`g : OTMX01ł̓ւ֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_disable_swap0(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAP &= ~WEX_SWAP0_bm;
}

/**
 * \brief g`g : OTMX01ł̓ւɏՕ
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_enable_swap0_buffer(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAPBUF |= WEX_SWAP0BUF_bm;
}

/**
 * \brief g`g : OTMX01ł̓ւɏՕ֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_disable_swap0_buffer(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAPBUF &= ~WEX_SWAP0BUF_bm;
}

/**
 * \brief g`g : OTMX23ł̓ւ
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_enable_swap1(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAP |= WEX_SWAP1_bm;
}

/**
 * \brief g`g : OTMX23ł̓ւ֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_disable_swap1(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAP &= ~WEX_SWAP1_bm;
}

/**
 * \brief g`g : OTMX23ł̓ւɏՕ
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_enable_swap1_buffer(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAPBUF |= WEX_SWAP1BUF_bm;
}

/**
 * \brief g`g : OTMX23ł̓ւɏՕ֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_disable_swap1_buffer(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAPBUF &= ~WEX_SWAP1BUF_bm;
}

/**
 * \brief g`g : OTMX45ł̓ւ
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_enable_swap2(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAP |= WEX_SWAP2_bm;
}

/**
 * \brief g`g : OTMX45ł̓ւ֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_disable_swap2(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAP &= ~WEX_SWAP2_bm;
}

/**
 * \brief g`g : OTMX45ł̓ւɏՕ
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_enable_swap2_buffer(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAPBUF |= WEX_SWAP2BUF_bm;
}

/**
 * \brief g`g : OTMX45ł̓ւɏՕ֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_disable_swap2_buffer(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAPBUF &= ~WEX_SWAP2BUF_bm;
}

/**
 * \brief g`g : OTMX67ł̓ւ
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_enable_swap3(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAP |= WEX_SWAP3_bm;
}

/**
 * \brief g`g : OTMX67ł̓ւ֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_disable_swap3(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAP &= ~WEX_SWAP3_bm;
}

/**
 * \brief g`g : OTMX67ł̓ւɏՕ
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_enable_swap3_buffer(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAPBUF |= WEX_SWAP3BUF_bm;
}

/**
 * \brief g`g : OTMX67ł̓ւɏՕ֎~
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 */
static inline void tc45_wex_disable_swap3_buffer(WEX_t *WEX)
{
	((WEX_t *)WEX)->SWAPBUF &= ~WEX_SWAP3BUF_bm;
}

/**
 * \brief g`g : ͗l^o͋`Ԑݒ
 *
 * \param  WEX   g`Pʕւ̈ʒuwq
 * \param  value ͗l^틖
 */

static inline void tc45_wex_write_pgo(WEX_t *WEX, int16_t value)
{
	((WEX_t *)WEX)->PGO = value;
}

/**
 * \brief g`g : ͗l^ɏՕo͋`Ԑݒ
 *
 * \param  WEX   g`Pʕւ̈ʒuwq
 * \param  value ͗l^틖
 */

static inline void tc45_wex_write_pgo_buffer(WEX_t *WEX, int16_t value)
{
	((WEX_t *)WEX)->PGOBUF = value;
}

/**
 * \brief g`g : ͗l^o͊ɏՕǂݍ
 *
 * \param  WEX g`Pʕւ̈ʒuwq
 *
 * \return ͗l^ɏՕ(PGOBUF)
 */
static inline uint16_t tc45_wex_read_pgo_buffer(volatile void *WEX)
{
	return (((WEX_t *)WEX)->PGOBUF);
}

/**
 * \brief g`g : ͗l^l`Ԑݒ
 *
 * \param  WEX   g`Pʕւ̈ʒuwq
 * \param  value PGOl
 */

static inline void tc45_wex_write_pgv(WEX_t *WEX, uint8_t value)
{
	((WEX_t *)WEX)->PGV = value;
}

/**
 * \brief g`g : ͗l^lɏՕ`Ԑݒ
 *
 * \param  WEX   g`Pʕւ̈ʒuwq
 * \param  value PGOl
 */

static inline void tc45_wex_write_pgv_buffer(WEX_t *WEX, uint8_t value)
{
	((WEX_t *)WEX)->PGVBUF = value;
}

/**
 * \brief g`g : o͏㏑`Ԑݒ
 *
 * \param  WEX   g`Pʕւ̈ʒuwq
 * \param  value ㏑l
 */

static inline void tc45_wex_set_output_override(WEX_t *WEX, uint8_t value)
{
	((WEX_t *)WEX)->OUTOVDIS = value;
}
/** @} */

/**
 * \ingroup tc45_group
 * \defgroup tc45_hires_group \gײ
 * ̌Q͍\g`Ԑݒ肷邽߂̒ײނ񋟂܂B
 * @{
 */

/**
 * \brief \g : \`Ԑݒ
 *
 * \param  hires       \Pʕւ̈ʒuwq
 * \param  hi_res_mode HIRES`Ԑݒ
 */
static inline void tc45_hires_set_mode(HIRES_t *hires, HIRES_HREN_t hi_res_mode)
{
	((HIRES_t *)hires)->CTRLA = hi_res_mode;
}
/** @} */

#ifdef __cplusplus
}
#endif

/**
 * \page xmega_tc45_quickstart XMEGA TC45ײޗpJn̎
 *
 * ͓̎gpʂɑ΂ײނ`Ԑݒ肵Ďgp@̒iKIȎw
 *  \ref tc45_group pJn̎łBޗ͗Ⴆ΁A/𐧌䂷
 * 邱ƂKvȎ剞pJԂA܂͑̉ꂩ̊֐ɕʂ邱Ƃł
 * B
 *
 *
 * \section xmega_tc45_qs_use_cases gp
 * - \ref xmega_tc45_qs_ovf
 * - \ref xmega_tc45_qs_cc
 * - \ref xmega_tc45_qs_pwm
 *
 *
 * \section xmega_tc45_qs_ovf (荞݂ɊÂ)/
 *
 * ̎gpʂ͌vꎞɊ荞݂N悤Ɍv܂B
 * ݂͓Ǝ\ȌĂі߂֐ɂď܂B
 *
 * vȉ̓ō\ݒ肵܂B
 * - WWGM(v)
 * - ۯƂļ ۯgp܂B
 * - OuȂ(ۯ1ɐݒ)
 * - 1000vɈꊄ荞ݔBTOPl1000ݒ肷邱Ƃɂčs
 *   ܂B
 *
 *
 * \section xmega_tc45_qs_ovf_setup \ݒiK
 *
 * \subsection xmega_tc45_qs_ovf_usage_prereq OKv
 *
 * ߂ɂ̎gpʂ̍\ݒ躰ނɂāAۼުĂɈȉǉȂ
 * ΂Ȃ܂B
 * - \ref interrupt_group "S̊荞݊Ǘ"
 * - \ref clk_group "ۯǗ"
 *
 * \subsection xmega_tc45_qs_ovf_setup_code ޗ
 *
 * ꊄ荞݋NɎsĂі߂֐ǉ܂B
 * \code
 * static void my_callback(void)
 * {
 *     // ͈ꔭɎs邽߂̎gpҺ
 * }
 * \endcode
 * Ⴆ΁ApÇق̎JԂɒǉ܂B
 * \code
 * sysclk_init();
 * tc45_enable(&TCC4);
 * tc45_set_overflow_interrupt_callback(&TCC4, my_callback);
 * tc45_set_wgm(&TCC4, TC45_WG_NORMAL);
 * tc45_write_period(&TCC4, 1000);
 * tc45_set_overflow_interrupt_level(&TCC4, TC45_INT_LVL_LO);
 * irq_initialize_vectors();
 * cpu_irq_enable();
 * tc45_write_clock_source(&TCC4, TC45_CLKSEL_DIV1_gc);
 * \endcode
 *
 * \subsection xmega_tc45_qs_ovf_setup_code_workflow Ƃ̗
 *
 * -# 荞ݐ܂B
 *  - \code irq_initialize_vectors(); \endcode
 * -# ۯ т܂B
 *  - \code sysclk_init(); \endcode
 * -# /TCC4܂B
 *  - \code tc45_enable(&TCC4); \endcode
 *    \note ͒Pʕp̸ۯ т܂B
 * -# ꊄ荞ݗpĂі߂֐ݒ肵܂B
 *  - \code tc45_set_overflow_interrupt_callback(&TCC4, my_callback); \endcode
 *    \warning ̊֐my_callback֐`邱ƂKvƂ܂B
 * -# ]ޔg`ݒ肵܂B
 *  - \code tc45_set_wgm(&TCC4, TC45_WG_NORMAL); \endcode
 *    \note ̏ꍇAv푝TOPlɒB܂ŒlvWg
            Bv͂̌ɂ̌vl0ؾĂ܂B
 * -# ()ݒ肵܂B
 *  - \code tc45_write_period(&TCC4, 1000); \endcode
 *    \note ͌vTOPlw肵܂Bv͂̒lɒBɈ
 *          Ă܂B
 * -# ꊄ荞قݒ肵܂B
 *   - \code tc45_set_overflow_interrupt_level(&TCC4, TC45_INT_LVL_LO); \endcode
 * -# 荞݂܂B
 *  - \code cpu_irq_enable(); \endcode
 * -# ۯݒ肵܂B
 *  - \code tc45_write_clock_source(&TCC4, TC45_CLKSEL_DIV1_gc); \endcode
 *    \warning ۯݒ肳ƁAv킪vJn܂B
 *
 * \section xmega_tc45_qs_ovf_usage giK
 *
 * - None. v͔wʂősAĂі߂֐ŏꂽނ͌v킪x
 *         s܂B
 *
 *
 * \section xmega_tc45_qs_cc (荞݂ɊÂ)/rv
 *
 * ̎gpʂ2̈قȂrlɒB鎞2̓Ɨ荞݂N
 * Ɍv܂Av͓̎Ǝ\ŁA2̔rl͌Ăі߂
 * Ŏ2̓Ɨ荞݂ɂď܂B
 *
 * v̓ō\ݒ肵܂B
 * - WWGM - v푝
 * - ۯƂļ ۯgp
 * - OuȂ(1ɐݒ)
 * - v̎10000v
 * - 100v̔rAv荞݋N
 * - 1000v̔rBv荞݋N
 * - rAƔrBɔꍇArB荂D挠ׂłB
 *
 *
 * \section xmega_tc45_qs_cc_setup ZݒiK
 *
 * \subsection xmega_tc45_qs_cc_usage_prereq OKv
 * ߂ɂ̎gpʂ̍\ݒ躰ނɂāAۼުĂɈȉǉȂ
 * ΂Ȃ܂B
 * - \ref interrupt_group "S̊荞݊Ǘ"
 * - \ref clk_group "ۯǗ"
 *
 * \subsection xmega_tc45_qs_cc_setup_code ޗ
 *
 * rAvƔrBv̔Ɏs2̌Ăі߂֐ǉ܂B
 * \code
 * static void my_cca_callback(void)
 * {
 *    // ArvɎs邽߂̎gpҺނ
 * }
 * static void my_ccb_callback(void)
 * {
 *    // BrvɎs邽߂̎gpҺނ
 * }
 * \endcode
 * Ⴆ΁ApÇقŎJԂɒǉ܂B
 * \code
 * sysclk_init();
 * irq_initialize_vectors();
 * cpu_irq_enable();
 * tc45_enable(&TCC4);
 * tc45_set_cca_interrupt_callback(&TCC4, my_cca_callback);
 * tc45_set_ccb_interrupt_callback(&TCC4, my_ccb_callback);
 * tc45_set_wgm(&TCC4, TC45_WG_NORMAL);
 * tc45_write_period(&TCC4, 10000);
 * tc45_write_cc(&TCC4, TC45_CCA, 100);
 * tc45_write_cc(&TCC4, TC45_CCB, 1000);
 * tc45_enable_cc_channels(&TCC4,(TC45_CCAEN | TC45_CCBEN));
 * tc45_set_cca_interrupt_level(&TCC4, TC45_INT_LVL_LO);
 * tc45_set_ccb_interrupt_level(&TCC4, TC45_INT_LVL_MED);
 * tc45_write_clock_source(&TCC4, TC45_CLKSEL_DIV1_gc);
 * \endcode
 *
 * \subsection xmega_tc45_qs_cc_setup_code_workflow Ƃ̗
 *
 * -# 荞ݐ܂B
 *  - \code irq_initialize_vectors(); \endcode
 * -# ۯ т܂B
 *  - \code sysclk_init(); \endcode
 * -# 荞݂܂B
 *  - \code cpu_irq_enable(); \endcode
 * -# /TCC4܂B
 *  - \code tc45_enable(&TCC4); \endcode
 *    \note ͂̒Pʕpɸۯ т܂B
 * -# CCA荞ݗpĂі߂֐ݒ肵܂B
 *  - \code tc45_set_cca_interrupt_callback(&TCC4, my_cca_callback); \endcode
 *    \warning ̊֐͌Ăі߂֐`邢邱ƂKvłB
 * -# CCB荞ݗpĂі߂֐ݒ肵܂B
 *  - \code tc45_set_ccb_interrupt_callback(&TCC4, my_ccb_callback); \endcode
 *    \warning ̊֐͌Ăі߂֐`邢邱ƂKvłB
 * -# ]ޔg`ݒ肵܂B
 *  - \code tc45_set_wgm(&TCC4, TC45_WG_NORMAL); \endcode
 *    \note ̏ꍇAv푝TOPlɒB܂ŒlvWgp
            ܂Bv͂̌Ɍvl0ؾĂ܂B
 * -# ()ݒ肵܂B
 *  - \code tc45_write_period(&TCC4, 10000); \endcode
 *    \note ͌vTOPlw肵܂Bv͂̒lɒBɈ
 *          Ă܂B
 * -# CCAɔrvlݒ肵܂B
 *   - \code tc45_write_cc(&TCC4, TC45_CCA, 100); \endcode
 * -# CCBɔrvlݒ肵܂B
 *   - \code tc45_write_cc(&TCC4, TC45_CCB, 1000); \endcode
 * -# rAƔrB܂B
 *  -\code tc45_enable_cc_channels(&TCC4, (TC45_CCAEN | TC45_CCBEN)); \endcode
 * -# Å荞قݒ肵܂(D挠B\ref TC45_INT_LEVEL_t B)
 *   - \code tc45_set_cca_interrupt_level(&TCC4, TC45_INT_LVL_LO); \endcode
 * -# B̊荞قݒ肵܂(D挠B\ref TC45_INT_LEVEL_t B)
 *   - \code tc45_set_ccb_interrupt_level(&TCC4, TC45_INT_LVL_MED); \endcode
 * -# ۯݒ肵܂B
 *  - \code tc45_write_clock_source(&TCC4, TC45_CLKSEL_DIV1_gc); \endcode
 *    \warning ۯݒ肳ƁAv킪vJn܂B
 *
 * \section xmega_tc45_qs_cc_usage giK
 *
 * - None. v͔wʂősAĂі߂֐ŏꂽނ͔rvN閈
 *         Ɏs܂B
 *
 *
 * \section xmega_tc45_qs_pwm /PWM
 * 
 * ̎gpʂ͌vPWMɍ\ݒ肵܂B葽̏ڍׂɂĂXMEGA
 *  PWM޽邱Ƃł܂B
 *
 * vȉ̂̓ɍ\ݒ肵܂B
 * - WWGM - v푝
 * - ۯƂ2MHzUgp()
 * - 1Hz PWMg(2MHzۯA1024OuATOPl1950)
 * - 10%ޭè (PERCCڼ޽Ԃ̔䗦1:10)
 * - PWMMI/O߰Ăɏo
 *
 * \section xmega_tc45_qs_pwm_setup \ݒiK
 *
 * \subsection xmega_tc45_qs_pwm_usage_prereq OKv
 * ߂ɂ̎gpʂ̍\ݒ躰ނɂāAۼުĂɈȉǉȂ
 * ΂Ȃ܂B
 * - \ref clk_group "Clock Management"
 *
 * \subsection xmega_tc45_qs_pwm_setup_code ޗ
 *
 * Ⴆ΁ApÇقŎJԂɒǉ܂B
 * \code
 * board_init();
 * sysclk_init();
 * tc45_enable(&TCC4);
 * tc45_set_wgm(&TCC4, TC45_WG_SS);
 * tc45_write_period(&TCC4, 1950);
 * tc45_write_cc(&TCC4, TC45_CCA, 195);
 * tc45_enable_cc_channels(&TCC4,TC45_CCAEN);
 * tc45_write_clock_source(&TCC4, TC45_CLKSEL_DIV1024_gc);
 * \endcode
 *
 * \subsection xmega_tc45_qs_pwm_setup_code_workflow Ƃ̗
 *
 * -# PWM I/O݂o͂ƂČ`Ԑݒ肳邱Ƃmɂ܂B
 *  - \code board_init(); \endcode
 *    \note board_init()֐I/O݂`Ԑݒ肵܂B̊֐sȂ
 *          AI/O݂͎蓮ŏo͂ƂČ`Ԑݒ肳Ȃ΂Ȃ܂B
 * -# ۯ т܂B
 *  - \code sysclk_init(); \endcode
 * -# /TCC4܂B
 *  - \code tc45_enable(&TCC4); \endcode
 *    \note ͂̒Pʕp̸ۯ т܂B
 * -# ]ޔg`ɐݒ肵܂B
 *  - \code tc45_set_wgm(&TCC4, TC45_WG_NORMAL); \endcode
 *    \note ̏ꍇAv푝TOPlɒB܂ŒlvWgp
            ܂Bv͂̌Ɍvl0ؾĂ܂B
 * -# ()ݒ肵܂B
 *  - \code tc45_write_period(&TCC4, 1950); \endcode
 *    \note ͌vTOPlw肵܂Bv͂̒lɒBɈ
 *          Ă܂B
 * -# CCAɔrvlݒ肵܂B
 *   - \code tc45_write_cc(&TCC4, TC45_CCA, 195); \endcode
 *     \note PWMޭè قPERCCAԂ̔䗦ŁAtc45_write_period()
 *           tc45_write_cc()̊֐ɂĐݒ肳܂Bsޭè ق
 *           X(ALED𒲌)ɂtc45_write_cc()gpĂB
 *           CCA=0Aޭè ق0%łBCCA=PER(TOPl)Aޭè ق100%
 *           łB
 * -# rA܂B
 *  -\code tc45_enable_cc_channels(&TCC4,TC45_CCAEN); \endcode
 * -# ۯݒ肵܂B
 *  - \code tc45_write_clock_source(&TCC4, TC45_CLKSEL_DIV1024_gc); \endcode
 *    \warning ۯݒ肳ƁAv킪vJn܂B
 *
 * \section xmega_tc45_qs_pwm_usage giK
 *  - PWMMޭè قύXɂtc45_write_cc()gp܂B
 *  - PWMgύXɂtc45_write_period()gp܂B
 */

#endif /* TC45_H */
